/**
 * Controls for zooming to particular ranges of the genome.
 * 
 */
'use strict';function _typeof(obj) {"@babel/helpers - typeof";if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {_typeof = function _typeof(obj) {return typeof obj;};} else {_typeof = function _typeof(obj) {return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;};}return _typeof(obj);}




var _react = _interopRequireDefault(require("react"));
var _underscore = _interopRequireDefault(require("underscore"));

var _utils = _interopRequireDefault(require("./utils"));
var _Interval = _interopRequireDefault(require("./Interval"));function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}function _createClass(Constructor, protoProps, staticProps) {if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function");}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);}function _setPrototypeOf(o, p) {_setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {o.__proto__ = p;return o;};return _setPrototypeOf(o, p);}function _createSuper(Derived) {var hasNativeReflectConstruct = _isNativeReflectConstruct();return function _createSuperInternal() {var Super = _getPrototypeOf(Derived),result;if (hasNativeReflectConstruct) {var NewTarget = _getPrototypeOf(this).constructor;result = Reflect.construct(Super, arguments, NewTarget);} else {result = Super.apply(this, arguments);}return _possibleConstructorReturn(this, result);};}function _possibleConstructorReturn(self, call) {if (call && (_typeof(call) === "object" || typeof call === "function")) {return call;}return _assertThisInitialized(self);}function _assertThisInitialized(self) {if (self === void 0) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return self;}function _isNativeReflectConstruct() {if (typeof Reflect === "undefined" || !Reflect.construct) return false;if (Reflect.construct.sham) return false;if (typeof Proxy === "function") return true;try {Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));return true;} catch (e) {return false;}}function _getPrototypeOf(o) {_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {return o.__proto__ || Object.getPrototypeOf(o);};return _getPrototypeOf(o);}var














Controls = /*#__PURE__*/function (_React$Component) {_inherits(Controls, _React$Component);var _super = _createSuper(Controls);



  function Controls(props) {var _this;_classCallCheck(this, Controls);
    _this = _super.call(this, props);
    _this.state = { defaultHalfInterval: 2 };return _this;
  }_createClass(Controls, [{ key: "makeRange", value:

    function makeRange() {
      return {
        contig: this.refs.contig.value,
        start: Number(this.refs.start.value),
        stop: Number(this.refs.stop.value) };

    } }, { key: "completeRange", value:

    function completeRange(range) {
      range = range || {};
      if (range.start && range.stop === undefined) {
        // Construct a range centered around a value. This matches IGV.
        range.stop = range.start + 20;
        range.start -= 20;
      }

      if (range.contig) {
        // There are major performance issues with having a 'chr' mismatch in the
        // global location object.
        var contig = range.contig;
        var altContig = _underscore["default"].find(this.props.contigList, function (ref) {return _utils["default"].isChrMatch(contig, ref.contig);});
        if (altContig) range.contig = altContig.contig;
      }

      return _underscore["default"].extend(_underscore["default"].clone(this.props.range), range);
    } }, { key: "handleContigChange", value:

    function handleContigChange(e) {
      this.props.onChange(this.completeRange({ contig: this.refs.contig.value }));
    } }, { key: "handleFormSubmit", value:

    function handleFormSubmit(e) {
      e.preventDefault();
      var range = this.completeRange(_utils["default"].parseRange(this.refs.position.value));
      this.props.onChange(range);
      this.updateSlider(new _Interval["default"](range.start, range.stop));
    } }, { key: "handleSliderOnInput", value:

    function handleSliderOnInput() {
      // value is a string, want valueAsNumber
      // slider has negative values to reverse its direction so we need to negate
      this.zoomAbs(-this.refs.slider.valueAsNumber);
    }

    // Sets the values of the input elements to match `props.range`.
  }, { key: "updateRangeUI", value: function updateRangeUI() {
      var r = this.props.range;
      if (!r) return;

      this.refs.position.value = _utils["default"].formatInterval(new _Interval["default"](r.start, r.stop));

      if (this.props.contigList) {
        var contigIdx = _underscore["default"].findIndex(this.props.contigList, function (ref) {return _utils["default"].isChrMatch(r.contig, ref.contig);});

        this.refs.contig.selectedIndex = contigIdx;
      }
    } }, { key: "zoomIn", value:

    function zoomIn(e) {
      e.preventDefault();
      this.zoomByFactor(_utils["default"].ZOOM_FACTOR.IN);
    } }, { key: "zoomOut", value:

    function zoomOut(e) {
      e.preventDefault();
      this.zoomByFactor(_utils["default"].ZOOM_FACTOR.OUT);
    }

    // Updates the range using absScaleRange and a given zoom level
    // Abs or absolute because it doesn't rely on scaling the current range
  }, { key: "zoomAbs", value: function zoomAbs(level) {
      var r = this.props.range;
      if (!r) return;

      var iv = _utils["default"].absScaleRange(new _Interval["default"](r.start, r.stop), level, this.state.defaultHalfInterval);
      this.props.onChange({
        contig: r.contig,
        start: iv.start,
        stop: iv.stop });

    } }, { key: "zoomByFactor", value:

    function zoomByFactor(factor) {
      var r = this.props.range;
      if (!r) return;

      var iv = _utils["default"].scaleRange(new _Interval["default"](r.start, r.stop), factor);
      this.props.onChange({
        contig: r.contig,
        start: iv.start,
        stop: iv.stop });

      this.updateSlider(iv);
    }

    // To be used if the range changes through a control besides the slider
    // Slider value is changed to roughly reflect the new range
  }, { key: "updateSlider", value: function updateSlider(newInterval) {
      var newSpan = newInterval.stop - newInterval.start;
      this.refs.slider.valueAsNumber = Math.ceil(-Math.log2(newSpan) + 1);
    } }, { key: "render", value:

    function render() {
      var contigOptions = this.props.contigList ?
      this.props.contigList.map(function (contig, i) {return /*#__PURE__*/_react["default"].createElement("option", { key: i }, contig.contig);}) :
      null;

      // Note: input values are set in componentDidUpdate.
      return /*#__PURE__*/(
        _react["default"].createElement("form", { className: "controls", onSubmit: this.handleFormSubmit.bind(this) }, /*#__PURE__*/
        _react["default"].createElement("select", { ref: "contig", onChange: this.handleContigChange.bind(this) },
        contigOptions),
        ' ', /*#__PURE__*/
        _react["default"].createElement("input", { ref: "position", type: "text" }), ' ', /*#__PURE__*/
        _react["default"].createElement("button", { className: "btn-submit", onClick: this.handleFormSubmit.bind(this) }, "Go"), ' ', /*#__PURE__*/
        _react["default"].createElement("div", { className: "zoom-controls" }, /*#__PURE__*/
        _react["default"].createElement("button", { className: "btn-zoom-out", onClick: this.zoomOut.bind(this) }), ' ', /*#__PURE__*/
        _react["default"].createElement("button", { className: "btn-zoom-in", onClick: this.zoomIn.bind(this) }), /*#__PURE__*/
        _react["default"].createElement("input", { className: "zoom-slider", ref: "slider", type: "range", min: "-15", max: "0", onInput: this.handleSliderOnInput.bind(this) }))));



    } }, { key: "componentDidUpdate", value:

    function componentDidUpdate(prevProps) {
      if (!_underscore["default"].isEqual(prevProps.range, this.props.range)) {
        this.updateRangeUI();
      }
      // Update slider if we have collected new information about a contig.
      if (!_underscore["default"].isEqual(prevProps.contigList, this.props.contigList)) {
        if (this.props.range != undefined) {
          var range = this.props.range; // flow
          if (range.contig != undefined) {
            var newInterval = _underscore["default"].find(this.props.contigList, function (ref) {return _utils["default"].isChrMatch(range.contig, ref.contig);});

            if (newInterval != undefined) {
              this.refs.slider.min = Math.ceil(-Math.log2(newInterval.stop()) + 1);
              this.updateSlider(new _Interval["default"](range.start, range.stop));
            }
          }
        }
      }
    } }, { key: "componentDidMount", value:

    function componentDidMount() {
      this.updateRangeUI();
    } }]);return Controls;}(_react["default"].Component);


module.exports = Controls;