/**
 * LocalStringFile is a representation of a file that was created from input string. Used for testing and small input files.
 * 
 */
'use strict';function _typeof(obj) {"@babel/helpers - typeof";if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {_typeof = function _typeof(obj) {return typeof obj;};} else {_typeof = function _typeof(obj) {return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;};}return _typeof(obj);}

var _q = _interopRequireDefault(require("q"));
var _AbstractFile2 = _interopRequireDefault(require("./AbstractFile"));function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}function _createClass(Constructor, protoProps, staticProps) {if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function");}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);}function _setPrototypeOf(o, p) {_setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {o.__proto__ = p;return o;};return _setPrototypeOf(o, p);}function _createSuper(Derived) {var hasNativeReflectConstruct = _isNativeReflectConstruct();return function _createSuperInternal() {var Super = _getPrototypeOf(Derived),result;if (hasNativeReflectConstruct) {var NewTarget = _getPrototypeOf(this).constructor;result = Reflect.construct(Super, arguments, NewTarget);} else {result = Super.apply(this, arguments);}return _possibleConstructorReturn(this, result);};}function _possibleConstructorReturn(self, call) {if (call && (_typeof(call) === "object" || typeof call === "function")) {return call;}return _assertThisInitialized(self);}function _assertThisInitialized(self) {if (self === void 0) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return self;}function _isNativeReflectConstruct() {if (typeof Reflect === "undefined" || !Reflect.construct) return false;if (Reflect.construct.sham) return false;if (typeof Proxy === "function") return true;try {Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));return true;} catch (e) {return false;}}function _getPrototypeOf(o) {_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {return o.__proto__ || Object.getPrototypeOf(o);};return _getPrototypeOf(o);}var

LocalStringFile = /*#__PURE__*/function (_AbstractFile) {_inherits(LocalStringFile, _AbstractFile);var _super = _createSuper(LocalStringFile);

  //content of this "File"


  function LocalStringFile(content) {var _this;_classCallCheck(this, LocalStringFile);
    _this = _super.call(this);
    _this.fileLength = content.length;
    _this.buffer = new ArrayBuffer(content.length); // 2 bytes for each char
    _this.content = content;

    var bufView = new Uint8Array(_this.buffer);
    for (var i = 0; i < _this.fileLength; i++) {
      bufView[i] = content.charCodeAt(i);
    }return _this;
  }_createClass(LocalStringFile, [{ key: "getBytes", value:

    function getBytes(start, length) {
      if (length < 0) {
        return _q["default"].reject("Requested <0 bytes (".concat(length, ")"));
      }

      // If the remote file length is known, clamp the request to fit within it.
      var stop = start + length - 1;
      if (this.fileLength != -1) {
        stop = Math.min(this.fileLength - 1, stop);
      }

      // First check the cache.
      var buf = this.getFromCache(start, stop);
      return _q["default"].when(buf);
    }

    // Read the entire file -- not recommended for large files!
  }, { key: "getAll", value: function getAll() {
      var buf = this.getFromCache(0, this.fileLength - 1);
      return _q["default"].when(buf);
    }

    // Reads the entire file as a string (not an ArrayBuffer).
    // This does not use the cache.
  }, { key: "getAllString", value: function getAllString() {
      return _q["default"].when(this.content);
    }

    // Returns a promise for the number of bytes in the remote file.
  }, { key: "getSize", value: function getSize() {
      return _q["default"].when(this.fileLength);
    } }, { key: "getFromCache", value:

    function getFromCache(start, stop) {
      return this.buffer.slice(start, stop + 1);
    } }]);return LocalStringFile;}(_AbstractFile2["default"]);



module.exports = LocalStringFile;