/**
 * RemoteFile is a representation of a file on a remote server which can be
 * fetched in chunks, e.g. using a Range request.
 * 
 */
'use strict';function _typeof(obj) {"@babel/helpers - typeof";if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {_typeof = function _typeof(obj) {return typeof obj;};} else {_typeof = function _typeof(obj) {return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;};}return _typeof(obj);}

var _q = _interopRequireDefault(require("q"));
var _AbstractFile2 = _interopRequireDefault(require("./AbstractFile"));function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}function _slicedToArray(arr, i) {return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();}function _nonIterableRest() {throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");}function _unsupportedIterableToArray(o, minLen) {if (!o) return;if (typeof o === "string") return _arrayLikeToArray(o, minLen);var n = Object.prototype.toString.call(o).slice(8, -1);if (n === "Object" && o.constructor) n = o.constructor.name;if (n === "Map" || n === "Set") return Array.from(o);if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);}function _arrayLikeToArray(arr, len) {if (len == null || len > arr.length) len = arr.length;for (var i = 0, arr2 = new Array(len); i < len; i++) {arr2[i] = arr[i];}return arr2;}function _iterableToArrayLimit(arr, i) {if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return;var _arr = [];var _n = true;var _d = false;var _e = undefined;try {for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {_arr.push(_s.value);if (i && _arr.length === i) break;}} catch (err) {_d = true;_e = err;} finally {try {if (!_n && _i["return"] != null) _i["return"]();} finally {if (_d) throw _e;}}return _arr;}function _arrayWithHoles(arr) {if (Array.isArray(arr)) return arr;}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}function _createClass(Constructor, protoProps, staticProps) {if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function");}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);}function _setPrototypeOf(o, p) {_setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {o.__proto__ = p;return o;};return _setPrototypeOf(o, p);}function _createSuper(Derived) {var hasNativeReflectConstruct = _isNativeReflectConstruct();return function _createSuperInternal() {var Super = _getPrototypeOf(Derived),result;if (hasNativeReflectConstruct) {var NewTarget = _getPrototypeOf(this).constructor;result = Reflect.construct(Super, arguments, NewTarget);} else {result = Super.apply(this, arguments);}return _possibleConstructorReturn(this, result);};}function _possibleConstructorReturn(self, call) {if (call && (_typeof(call) === "object" || typeof call === "function")) {return call;}return _assertThisInitialized(self);}function _assertThisInitialized(self) {if (self === void 0) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return self;}function _isNativeReflectConstruct() {if (typeof Reflect === "undefined" || !Reflect.construct) return false;if (Reflect.construct.sham) return false;if (typeof Proxy === "function") return true;try {Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));return true;} catch (e) {return false;}}function _getPrototypeOf(o) {_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {return o.__proto__ || Object.getPrototypeOf(o);};return _getPrototypeOf(o);}var









RemoteFile = /*#__PURE__*/function (_AbstractFile) {_inherits(RemoteFile, _AbstractFile);var _super = _createSuper(RemoteFile);


  // regions of file that have already been loaded.
  // track this for debugging/testing

  function RemoteFile(url) {var _this;_classCallCheck(this, RemoteFile);
    _this = _super.call(this);
    _this.url = url;
    _this.fileLength = -1; // unknown
    _this.chunks = [];
    _this.numNetworkRequests = 0;return _this;
  }_createClass(RemoteFile, [{ key: "getBytes", value:

    function getBytes(start, length) {
      if (length < 0) {
        return _q["default"].reject("Requested <0 bytes (".concat(length, ") from ").concat(this.url));
      }

      // If the remote file length is known, clamp the request to fit within it.
      var stop = start + length - 1;
      if (this.fileLength != -1) {
        stop = Math.min(this.fileLength - 1, stop);
      }

      // First check the cache.
      var buf = this.getFromCache(start, stop);
      if (buf) {
        return _q["default"].when(buf);
      }

      // TODO: handle partial overlap of request w/ cache.

      // Need to fetch from the network.
      return this.getFromNetwork(start, stop);
    }

    // Read the entire file -- not recommended for large files!
  }, { key: "getAll", value: function getAll() {var _this2 = this;
      // Check cache if file length is available.
      if (this.fileLength != -1) {
        var buf = this.getFromCache(0, this.fileLength - 1);
        if (buf) {
          return _q["default"].when(buf);
        }
      }

      var xhr = new XMLHttpRequest();
      xhr.open('GET', this.url);
      xhr.responseType = 'arraybuffer';
      return this.promiseXHR(xhr).then(function (_ref) {var _ref2 = _slicedToArray(_ref, 1),buffer = _ref2[0];
        _this2.fileLength = buffer.byteLength;
        _this2.chunks = [{ start: 0, stop: _this2.fileLength - 1, buffer: buffer }];
        return buffer;
      });
    }

    // Reads the entire file as a string (not an ArrayBuffer).
    // This does not use the cache.
  }, { key: "getAllString", value: function getAllString() {
      var xhr = new XMLHttpRequest();
      xhr.open('GET', this.url);
      return this.promiseXHR(xhr).then(function (_ref3) {var _ref4 = _slicedToArray(_ref3, 1),string = _ref4[0];
        return string;
      });
    }

    // Returns a promise for the number of bytes in the remote file.
  }, { key: "getSize", value: function getSize() {
      if (this.fileLength != -1) {
        return _q["default"].when(this.fileLength);
      }

      var xhr = new XMLHttpRequest();
      xhr.open('HEAD', this.url);

      return this.promiseXHR(xhr).then(function () {
        // event.total would be better, see facebook/flow#357
        var len = xhr.getResponseHeader('Content-Length');
        if (len !== null) {
          return Number(len);
        } else {
          throw 'Remote resource has unknown length';
        }
      });
    } }, { key: "getFromCache", value:

    function getFromCache(start, stop) {
      for (var i = 0; i < this.chunks.length; i++) {
        var chunk = this.chunks[i];
        if (chunk.start <= start && chunk.stop >= stop) {
          return chunk.buffer.slice(start - chunk.start, stop - chunk.start + 1);
        }
      }
      return null;
    } }, { key: "getFromNetwork", value:

    function getFromNetwork(start, stop) {var _this3 = this;
      var length = stop - start + 1;
      if (length > 50000000) {
        throw "Monster request: Won't fetch ".concat(length, " bytes from ").concat(this.url);
      }

      var xhr = new XMLHttpRequest();
      xhr.open('GET', this.url);
      xhr.responseType = 'arraybuffer';
      xhr.setRequestHeader('Range', "bytes=".concat(start, "-").concat(stop));

      return this.promiseXHR(xhr).then(function (_ref5) {var _ref6 = _slicedToArray(_ref5, 1),buffer = _ref6[0];
        // The actual length of the response may be less than requested if it's
        // too short, e.g. if we request bytes 0-1000 of a 500-byte file.
        var newChunk = { start: start, stop: start + buffer.byteLength - 1, buffer: buffer };
        _this3.chunks.push(newChunk);

        // Record the full file length if it's available.
        var size = _this3._getLengthFromContentRange(xhr);
        if (size !== null && size !== undefined) {
          if (_this3.fileLength != -1 && _this3.fileLength != size) {
            console.warn("Size of remote file ".concat(_this3.url, " changed from ") + "".concat(
            _this3.fileLength, " to ").concat(size));
          } else {
            _this3.fileLength = size;
          }
        }

        return buffer;
      });
    }

    // Wrapper to convert XHRs to Promises.
    // The promised values are the response (e.g. an ArrayBuffer) and the Event.
  }, { key: "promiseXHR", value: function promiseXHR(xhr) {
      var url = this.url;
      var deferred = _q["default"].defer();
      xhr.addEventListener('load', function (e) {
        if (this.status >= 400) {
          deferred.reject("Request for ".concat(url, " failed with status: ").concat(this.status, " ").concat(this.statusText));
        } else {
          deferred.resolve([this.response, e]);
        }
      });
      xhr.addEventListener('error', function (e) {
        deferred.reject("Request for ".concat(url, " failed with status: ").concat(this.status, " ").concat(this.statusText));
      });
      this.numNetworkRequests++;
      xhr.send();
      return deferred.promise;
    }

    // Attempting to access Content-Range directly may raise security errors.
    // This ensures the access is safe before making it.
  }, { key: "_getLengthFromContentRange", value: function _getLengthFromContentRange(xhr) {
      if (!/Content-Range/i.exec(xhr.getAllResponseHeaders())) {
        return null;
      }

      var contentRange = xhr.getResponseHeader('Content-Range');
      var m = /\/(\d+)$/.exec(contentRange);
      if (m) {
        return Number(m[1]);
      }
      console.warn("Received improper Content-Range value for " + "".concat(
      this.url, ": ").concat(contentRange));
      return null;
    } }, { key: "clearCache", value:

    function clearCache() {
      this.chunks = [];
    } }]);return RemoteFile;}(_AbstractFile2["default"]);


module.exports = RemoteFile;