/**
 * Root of the React component tree.
 * 
 */
'use strict';function _typeof(obj) {"@babel/helpers - typeof";if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {_typeof = function _typeof(obj) {return typeof obj;};} else {_typeof = function _typeof(obj) {return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;};}return _typeof(obj);}





var _utils = _interopRequireDefault(require("./utils"));
var _underscore = _interopRequireDefault(require("underscore"));

var _react = _interopRequireDefault(require("react"));
var _Controls = _interopRequireDefault(require("./Controls"));
var _Menu = _interopRequireDefault(require("./Menu"));
var _VisualizationWrapper = _interopRequireDefault(require("./VisualizationWrapper"));function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}function _createClass(Constructor, protoProps, staticProps) {if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function");}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);}function _setPrototypeOf(o, p) {_setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {o.__proto__ = p;return o;};return _setPrototypeOf(o, p);}function _createSuper(Derived) {var hasNativeReflectConstruct = _isNativeReflectConstruct();return function _createSuperInternal() {var Super = _getPrototypeOf(Derived),result;if (hasNativeReflectConstruct) {var NewTarget = _getPrototypeOf(this).constructor;result = Reflect.construct(Super, arguments, NewTarget);} else {result = Super.apply(this, arguments);}return _possibleConstructorReturn(this, result);};}function _possibleConstructorReturn(self, call) {if (call && (_typeof(call) === "object" || typeof call === "function")) {return call;}return _assertThisInitialized(self);}function _assertThisInitialized(self) {if (self === void 0) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return self;}function _isNativeReflectConstruct() {if (typeof Reflect === "undefined" || !Reflect.construct) return false;if (Reflect.construct.sham) return false;if (typeof Proxy === "function") return true;try {Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));return true;} catch (e) {return false;}}function _getPrototypeOf(o) {_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {return o.__proto__ || Object.getPrototypeOf(o);};return _getPrototypeOf(o);}var














Root = /*#__PURE__*/function (_React$Component) {_inherits(Root, _React$Component);var _super = _createSuper(Root);


  //it's an array of reactelement that are created for tracks

  // used to track clicking outside this component

  function Root(props) {var _this;_classCallCheck(this, Root);
    _this = _super.call(this, props);
    _this.state = {
      contigList: _this.props.referenceSource.contigList(),
      range: null,
      updateSize: false,
      settingsMenuKey: null };

    _this.trackReactElements = [];
    _this.node = null;
    _this.outsideClickHandler = _this.handleOutsideClick.bind(_assertThisInitialized(_this));return _this;
  }_createClass(Root, [{ key: "componentDidMount", value:

    function componentDidMount() {var _this2 = this;
      this.props.referenceSource.on('contigs', function () {
        _this2.updateOutOfBoundsChromosome();
      });

      if (!this.state.range) {
        this.handleRangeChange(this.props.initialRange);
      }
      // in case the contigs came in between getInitialState() and here.
      this.setState({ contigList: this.props.referenceSource.contigList() });
    } }, { key: "handleRangeChange", value:

    function handleRangeChange(newRange) {var _this3 = this;

      // copy over range so you don't modify
      // this.state.range, which is bound to handleRangeChange
      var modifiedRange = {
        contig: newRange.contig,
        start: newRange.start,
        stop: newRange.stop };


      // Do not propagate negative ranges
      if (modifiedRange.start < 0) {
        modifiedRange.start = 0;
      }
      // Do not propogate ranges exceeding contig limit
      var contigInfo = _underscore["default"].find(this.state.contigList, function (ref) {return _utils["default"].isChrMatch(modifiedRange.contig, ref.contig);});

      if (contigInfo != undefined) {
        if (modifiedRange.stop > contigInfo.stop()) {
          modifiedRange.stop = contigInfo.stop();
          if (modifiedRange.start > modifiedRange.stop) {
            modifiedRange.start = 0;
          }
        }
      }

      this.props.referenceSource.normalizeRange(modifiedRange).then(function (range) {
        _this3.setState({ range: range });
        // Inform all the sources of the range change (including referenceSource).
        _this3.props.tracks.forEach(function (track) {
          track.source.rangeChanged(range);
        });
      }).done();
    }

    // key can be string or null
  }, { key: "toggleSettingsMenu", value: function toggleSettingsMenu(key, e) {
      if (this.state.settingsMenuKey == key) {
        this.setState({ settingsMenuKey: null });
        document.removeEventListener('click', this.outsideClickHandler, false);
      } else {
        this.setState({ settingsMenuKey: key });
        // remove event listener for clicking off of menu
        document.addEventListener('click', this.outsideClickHandler, false);
      }
    } }, { key: "handleOutsideClick", value:

    function handleOutsideClick(e) {
      // if menu is visible and click is outside of menu component,
      // toggle view off
      if (this.state.settingsMenuKey != null && this.state.settingsMenuKey != undefined) {
        if (!this.node.contains(e.target)) {
          this.toggleSettingsMenu(this.state.settingsMenuKey, e);
        }
      }
    } }, { key: "handleSelectOption", value:

    function handleSelectOption(trackKey, item) {
      var viz = this.props.tracks[Number(trackKey)].visualization;
      var oldOpts = viz.options;
      // $FlowIgnore: TODO remove flow suppression
      var newOpts = viz.component.handleSelectOption(item, oldOpts);
      viz.options = newOpts;
      if (newOpts != oldOpts) {
        this.forceUpdate();
      }
    } }, { key: "makeDivForTrack", value:

    function makeDivForTrack(key, track) {var _this4 = this;
      //this should be improved, but I have no idea how (when trying to
      //access this.trackReactElements with string key, flow complains)
      var intKey = parseInt(key);
      var trackEl = /*#__PURE__*/
      _react["default"].createElement(_VisualizationWrapper["default"], { visualization: track.visualization,
        range: this.state.range,
        onRangeChange: this.handleRangeChange.bind(this),
        source: track.source,
        options: track.track.options,
        referenceSource: this.props.referenceSource,
        ref: function ref(c) {_this4.trackReactElements[intKey] = c;} });


      var trackName = track.track.name || '(track name)';

      var gearIcon = null,
      settingsMenu = null;
      // $FlowIgnore: TODO remove flow suppression
      if (track.visualization.component.getOptionsMenu) {
        gearIcon = /*#__PURE__*/
        _react["default"].createElement("span", { ref: 'gear-' + key,
          className: "gear",
          onClick: this.toggleSettingsMenu.bind(this, key) }, "\u2699");



      }

      if (this.state.settingsMenuKey == key) {
        var gear = this.refs['gear-' + key],
        gearX = gear.offsetLeft,
        gearW = gear.offsetWidth,
        gearY = gear.offsetTop;

        var menuStyle = {
          position: 'absolute',
          left: gearX + gearW + 'px',
          top: gearY + 'px' };

        // $FlowIgnore: TODO remove flow suppression
        var items = _underscore["default"].clone(track.visualization.component.getOptionsMenu(track.visualization.options));
        settingsMenu = /*#__PURE__*/
        _react["default"].createElement("div", { className: "menu-container", style: menuStyle, ref: function ref(node) {_this4.node = node;} }, /*#__PURE__*/
        _react["default"].createElement(_Menu["default"], { header: trackName, items: items,
          onClick: this.handleSelectOption.bind(this, key) }));



      }

      var className = ['track', track.visualization.component.displayName || '', track.track.cssClass || ''].join(' ');

      return /*#__PURE__*/(
        _react["default"].createElement("div", { key: key, className: className }, /*#__PURE__*/
        _react["default"].createElement("div", { className: "track-label" }, /*#__PURE__*/
        _react["default"].createElement("span", null, trackName), /*#__PURE__*/
        _react["default"].createElement("br", null),
        gearIcon,
        settingsMenu), /*#__PURE__*/

        _react["default"].createElement("div", { className: "track-content" },
        trackEl)));



    } }, { key: "render", value:

    function render() {var _this5 = this;
      // TODO: use a better key than index.
      var trackEls = this.props.tracks.map(function (t, i) {return _this5.makeDivForTrack('' + i, t);});
      return /*#__PURE__*/(
        _react["default"].createElement("div", { className: "pileup-root" }, /*#__PURE__*/
        _react["default"].createElement("div", { className: "track controls" }, /*#__PURE__*/
        _react["default"].createElement("div", { className: "track-label" }, "\xA0"), /*#__PURE__*/


        _react["default"].createElement("div", { className: "track-content" }, /*#__PURE__*/
        _react["default"].createElement(_Controls["default"], { contigList: this.state.contigList,
          range: this.state.range,
          onChange: this.handleRangeChange.bind(this) }))),


        trackEls));


    } }, { key: "updateOutOfBoundsChromosome", value:

    function updateOutOfBoundsChromosome() {
      // We don't want to allow users to go to regions that extend past the end of
      // a contig. This function truncates queries past the ends of a contig
      // and updates the required states.

      var current_contig = this.props.initialRange.contig;
      if (this.state.range) {
        current_contig = this.state.range.contig;
      }

      var oldContig = _underscore["default"].find(this.state.contigList, function (ref) {return (
          _utils["default"].isChrMatch(current_contig,
          ref.contig));});

      var contigList = this.props.referenceSource.contigList();

      var newContig = _underscore["default"].find(contigList, function (ref) {return _utils["default"].isChrMatch(current_contig, ref.contig);});

      // only update if the current contig has new information regarding
      // the end of the chromosome AND the current range is out of bounds
      // with respect to chromosome length
      if (this.state.contigList.length == 0) {
        this.setState({
          contigList: contigList });

      }

      if (newContig && oldContig) {
        if (!_underscore["default"].isEqual(oldContig, newContig)) {
          // only trigger state if current contig changed
          this.setState({
            contigList: contigList });

          if (this.state.range !== null && this.state.range !== undefined) {
            if (this.state.range.stop > newContig.stop()) {
              // $FlowIgnore: TODO remove flow suppression
              this.handleRangeChange(this.state.range);
            }
          }
        }
      }
    } }, { key: "componentDidUpdate", value:

    function componentDidUpdate(prevProps, prevState) {var _this6 = this;
      if (this.state.updateSize) {
        for (var i = 0; i < this.props.tracks.length; i++) {
          this.trackReactElements[i].setState({ updateSize: this.state.updateSize });
        }
        this.state.updateSize = false;
      }

      this.props.referenceSource.on('contigs', function () {
        _this6.updateOutOfBoundsChromosome();
      });
    } }]);return Root;}(_react["default"].Component);


Root.displayName = 'Root';

module.exports = Root;