
'use strict';function _typeof(obj) {"@babel/helpers - typeof";if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {_typeof = function _typeof(obj) {return typeof obj;};} else {_typeof = function _typeof(obj) {return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;};}return _typeof(obj);}

var _underscore = _interopRequireDefault(require("underscore"));
var _Interval2 = _interopRequireDefault(require("../Interval"));function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function");}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);}function _setPrototypeOf(o, p) {_setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {o.__proto__ = p;return o;};return _setPrototypeOf(o, p);}function _createSuper(Derived) {var hasNativeReflectConstruct = _isNativeReflectConstruct();return function _createSuperInternal() {var Super = _getPrototypeOf(Derived),result;if (hasNativeReflectConstruct) {var NewTarget = _getPrototypeOf(this).constructor;result = Reflect.construct(Super, arguments, NewTarget);} else {result = Super.apply(this, arguments);}return _possibleConstructorReturn(this, result);};}function _possibleConstructorReturn(self, call) {if (call && (_typeof(call) === "object" || typeof call === "function")) {return call;}return _assertThisInitialized(self);}function _assertThisInitialized(self) {if (self === void 0) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return self;}function _isNativeReflectConstruct() {if (typeof Reflect === "undefined" || !Reflect.construct) return false;if (Reflect.construct.sham) return false;if (typeof Proxy === "function") return true;try {Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));return true;} catch (e) {return false;}}function _getPrototypeOf(o) {_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {return o.__proto__ || Object.getPrototypeOf(o);};return _getPrototypeOf(o);}var

CodingInterval = /*#__PURE__*/function (_Interval) {_inherits(CodingInterval, _Interval);var _super = _createSuper(CodingInterval);

  function CodingInterval(start, stop, isCoding) {var _this;_classCallCheck(this, CodingInterval);
    _this = _super.call(this, start, stop);
    _this.isCoding = isCoding;return _this;
  }return CodingInterval;}(_Interval2["default"]);


/**
 * Split exons which cross the coding/non-coding boundary into purely coding &
 * non-coding parts.
 */
function splitCodingExons(exons,
codingRegion) {
  return _underscore["default"].flatten(exons.map(function (exon) {
    // Special case: the coding region is entirely contained by this exon.
    if (exon.containsInterval(codingRegion)) {
      // split into three parts.
      return [
      new CodingInterval(exon.start, codingRegion.start - 1, false),
      new CodingInterval(codingRegion.start, codingRegion.stop, true),
      new CodingInterval(codingRegion.stop + 1, exon.stop, false)].
      filter(function (interval) {return interval.start <= interval.stop;});
    }

    var startIsCoding = codingRegion.contains(exon.start),
    stopIsCoding = codingRegion.contains(exon.stop);
    if (startIsCoding == stopIsCoding) {
      return [new CodingInterval(exon.start, exon.stop, startIsCoding)];
    } else if (startIsCoding) {
      return [
      new CodingInterval(exon.start, codingRegion.stop, true),
      new CodingInterval(codingRegion.stop + 1, exon.stop, false)];

    } else {
      return [
      new CodingInterval(exon.start, codingRegion.start - 1, false),
      new CodingInterval(codingRegion.start, exon.stop, true)];

    }
  }));
}

module.exports = { splitCodingExons: splitCodingExons, CodingInterval: CodingInterval };