/**
 * Class for parsing chromosome bands for idiograms.
 * Format taken from https://github.com/hammerlab/idiogrammatik.
 * 
 */
'use strict';

var _ContigInterval = _interopRequireDefault(require("../ContigInterval"));

var _underscore = _interopRequireDefault(require("underscore"));function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}function _createClass(Constructor, protoProps, staticProps) {if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;}var










Chromosome = /*#__PURE__*/function () {




  function Chromosome(chromosome) {_classCallCheck(this, Chromosome);
    this.name = chromosome.name;
    this.bands = chromosome.bands;
    // create region for chromosome
    var start = _underscore["default"].min(this.bands, function (band) {return band.start;}).start;


    var stop = _underscore["default"].max(this.bands, function (band) {return band.end;}).end;
    this.position = new _ContigInterval["default"](this.name, start, stop);
  }_createClass(Chromosome, [{ key: "getKey", value:

    function getKey() {
      return this.name;
    } }, { key: "getInterval", value:

    function getInterval() {
      return this.position;
    } }, { key: "getCoverage", value:

    function getCoverage(referenceSource) {
      return {
        range: this.getInterval(),
        opInfo: null };

    } }, { key: "intersects", value:

    function intersects(range) {
      return range.intersects(this.position);
    } }]);return Chromosome;}();


module.exports = Chromosome;