/**
 * AbstractCache
 * 
 */
'use strict';

var _underscore = _interopRequireDefault(require("underscore"));

var _ContigInterval = _interopRequireDefault(require("../ContigInterval"));
var _Interval = _interopRequireDefault(require("../Interval"));

var _utils = _interopRequireDefault(require("../utils"));




var _genericFeature = _interopRequireDefault(require("../data/genericFeature.js"));function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}function _createClass(Constructor, protoProps, staticProps) {if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;}var










AbstractCache = /*#__PURE__*/function () {
  // maps groupKey to VisualGroup




  function AbstractCache(referenceSource) {_classCallCheck(this, AbstractCache);
    this.groups = {};
    this.refToPileup = {};
    this.referenceSource = referenceSource;
  }_createClass(AbstractCache, [{ key: "pileupForRef", value:

    function pileupForRef(ref) {
      if (ref in this.refToPileup) {
        return this.refToPileup[ref];
      } else {
        var alt = _utils["default"].altContigName(ref);
        if (alt in this.refToPileup) {
          return this.refToPileup[alt];
        } else {
          return [];
        }
      }
    }

    // How many rows tall is the pileup for a given ref? This is related to the
    // maximum read depth. This is 'chr'-agnostic.
  }, { key: "pileupHeightForRef", value: function pileupHeightForRef(ref) {
      var pileup = this.pileupForRef(ref);
      return pileup ? pileup.length : 0;
    }

    // Find groups overlapping the range. This is 'chr'-agnostic.
  }, { key: "getGroupsOverlapping", value: function getGroupsOverlapping(range) {
      // TODO: speed this up using an interval tree
      return _underscore["default"].filter(this.groups, function (group) {return group.span.intersects(range);});
    }

    // Determine the number of groups at a locus.
    // Like getGroupsOverlapping(range).length > 0, but more efficient.
  }, { key: "anyGroupsOverlapping", value: function anyGroupsOverlapping(range) {
      for (var k in this.groups) {
        var group = this.groups[k];
        if (group.span.intersects(range)) {
          return true;
        }
      }
      return false;
    } }]);return AbstractCache;}();


module.exports = AbstractCache;