/**
 * Coverage visualization of Alignment sources.
 * 
 */
'use strict';function _typeof(obj) {"@babel/helpers - typeof";if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {_typeof = function _typeof(obj) {return typeof obj;};} else {_typeof = function _typeof(obj) {return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;};}return _typeof(obj);}



var _feature = _interopRequireDefault(require("../data/feature"));





var _react = _interopRequireDefault(require("react"));
var _scale = _interopRequireDefault(require("../scale"));
var _shallowEquals = _interopRequireDefault(require("shallow-equals"));
var _d3utils = _interopRequireDefault(require("./d3utils"));
var _underscore = _interopRequireDefault(require("underscore"));
var _dataCanvas = _interopRequireDefault(require("data-canvas"));
var _canvasUtils = _interopRequireDefault(require("./canvas-utils"));
var _CoverageCache = _interopRequireDefault(require("./CoverageCache"));
var _TiledCanvas2 = _interopRequireDefault(require("./TiledCanvas"));
var _style = _interopRequireDefault(require("../style"));
var _ContigInterval = _interopRequireDefault(require("../ContigInterval"));function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}function _createClass(Constructor, protoProps, staticProps) {if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function");}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);}function _setPrototypeOf(o, p) {_setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {o.__proto__ = p;return o;};return _setPrototypeOf(o, p);}function _createSuper(Derived) {var hasNativeReflectConstruct = _isNativeReflectConstruct();return function _createSuperInternal() {var Super = _getPrototypeOf(Derived),result;if (hasNativeReflectConstruct) {var NewTarget = _getPrototypeOf(this).constructor;result = Reflect.construct(Super, arguments, NewTarget);} else {result = Super.apply(this, arguments);}return _possibleConstructorReturn(this, result);};}function _possibleConstructorReturn(self, call) {if (call && (_typeof(call) === "object" || typeof call === "function")) {return call;}return _assertThisInitialized(self);}function _assertThisInitialized(self) {if (self === void 0) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return self;}function _isNativeReflectConstruct() {if (typeof Reflect === "undefined" || !Reflect.construct) return false;if (Reflect.construct.sham) return false;if (typeof Proxy === "function") return true;try {Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));return true;} catch (e) {return false;}}function _getPrototypeOf(o) {_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {return o.__proto__ || Object.getPrototypeOf(o);};return _getPrototypeOf(o);}

// Basic setup (TODO: make this configurable by the user)
var SHOW_MISMATCHES = true;

// Only show mismatch information when there are more than this many
// reads supporting that mismatch.
var MISMATCH_THRESHOLD = 1;var


CoverageTiledCanvas = /*#__PURE__*/function (_TiledCanvas) {_inherits(CoverageTiledCanvas, _TiledCanvas);var _super = _createSuper(CoverageTiledCanvas);





  function CoverageTiledCanvas(cache, height, options) {var _this;_classCallCheck(this, CoverageTiledCanvas);
    _this = _super.call(this);

    _this.cache = cache;
    _this.height = Math.max(1, height);
    _this.options = options;
    _this.maxCoverage = 0;return _this;
  }_createClass(CoverageTiledCanvas, [{ key: "heightForRef", value:

    function heightForRef(ref) {
      return this.height;
    } }, { key: "update", value:

    function update(height, options) {
      // workaround for an issue in PhantomJS where height always comes out to zero.
      this.height = Math.max(1, height);
      this.options = options;
    } }, { key: "yScaleForRef", value:

    function yScaleForRef(bottomPadding, topPadding) {
      return _scale["default"].linear().
      domain([Math.max(10, this.maxCoverage), 0]) // minimum coverage = 10
      .range([bottomPadding, this.height - topPadding]).
      nice();
    } }, { key: "render", value:

    function render(ctx,
    xScale,
    range) {
      var bins = this.cache.binsForRef(range.contig);
      var yScale = this.yScaleForRef(10, 10);
      var relaxedRange = new _ContigInterval["default"](
      range.contig, range.start() - 1, range.stop() + 1);
      renderBars(ctx, xScale, yScale, relaxedRange, bins, this.options);
    } }]);return CoverageTiledCanvas;}(_TiledCanvas2["default"]);



// Draw coverage bins & mismatches
function renderBars(ctx,
xScale,
yScale,
range,
bins,
options) {
  if (_underscore["default"].isEmpty(bins)) return;

  var barWidth = xScale(1) - xScale(0);
  var showPadding = barWidth > _style["default"].COVERAGE_MIN_BAR_WIDTH_FOR_GAP;
  var padding = showPadding ? 1 : 0;

  var binPos = function binPos(pos, count) {
    // Round to integer coordinates for crisp lines, without aliasing.
    var barX1 = Math.round(xScale(1 + pos)),
    barX2 = Math.round(xScale(2 + pos)) - padding,
    barY = Math.round(yScale(count));
    return { barX1: barX1, barX2: barX2, barY: barY };
  };

  var mismatchBins = {}; // keep track of which ones have mismatches
  var vBasePosY = yScale(0); // the very bottom of the canvas
  var start = range.start(),
  stop = range.stop();

  // track last genomic position
  var lastPos = null;

  for (var pos = start; pos < stop; pos++) {
    var bin = bins[pos];
    if (!bin) continue;

    // Restart path if first position or no bins before
    if (!lastPos || !bins[pos - 1]) {var _binPos =
      binPos(pos, bin.count),_barX = _binPos.barX1;
      ctx.fillStyle = "rgba(".concat(options.color.rgb.r, ", ").concat(options.color.rgb.g, ", ").concat(options.color.rgb.b, ", ").concat(options.color.rgb.a, ")");
      ctx.beginPath();
      ctx.moveTo(_barX, vBasePosY);
    }

    ctx.pushObject(bin);var _binPos2 =
    binPos(pos, bin.count),barX1 = _binPos2.barX1,barX2 = _binPos2.barX2,barY = _binPos2.barY;
    ctx.lineTo(barX1, barY);
    ctx.lineTo(barX2, barY);
    if (showPadding) {
      ctx.lineTo(barX2, vBasePosY);
      ctx.lineTo(barX2 + 1, vBasePosY);
    }
    // close current path if next bin is going to be undefined
    if (!bins[pos + 1]) {
      ctx.lineTo(barX2, vBasePosY); // right edge of the right bar.
      ctx.closePath();
      ctx.fill();
    }

    if (SHOW_MISMATCHES && !_underscore["default"].isEmpty(bin.mismatches)) {
      mismatchBins[pos] = bin;
    }
    lastPos = pos;
    ctx.popObject();
  }

  if (lastPos) {var _binPos3 =
    binPos(lastPos, 0),_barX2 = _binPos3.barX2; // count does not matter, drawing vBasePosY
    ctx.lineTo(_barX2, vBasePosY); // right edge of the right bar.
    ctx.closePath();
    ctx.fill();
  }

  // Now render the mismatches
  _underscore["default"].each(mismatchBins, function (bin, pos) {
    if (!bin.mismatches) return; // this is here for Flow; it can't really happen.
    var mismatches = _underscore["default"].clone(bin.mismatches);
    pos = Number(pos); // object keys are strings, not numbers.

    // If this is a high-frequency variant, add in the reference.
    var mismatchCount = _underscore["default"].reduce(mismatches, function (x, y) {return x + y;});
    var mostFrequentMismatch = _underscore["default"].max(mismatches);
    if (mostFrequentMismatch > MISMATCH_THRESHOLD &&
    mismatchCount > options.vafColorThreshold * bin.count &&
    mismatchCount < bin.count) {
      if (bin.ref) {// here for flow; can't realy happen
        mismatches[bin.ref] = bin.count - mismatchCount;
      }
    }var _binPos4 =

    binPos(pos, bin.count),barX1 = _binPos4.barX1,barX2 = _binPos4.barX2;
    ctx.pushObject(bin);
    var countSoFar = 0;
    _underscore["default"].chain(mismatches).
    map(function (count, base) {return { count: count, base: base };}) // pull base into the object
    .filter(function (_ref) {var count = _ref.count;return count > MISMATCH_THRESHOLD;}).
    sortBy(function (_ref2) {var count = _ref2.count;return -count;}) // the most common mismatch at the bottom
    .each(function (_ref3) {var count = _ref3.count,base = _ref3.base;
      var misMatchObj = { position: 1 + pos, count: count, base: base };
      ctx.pushObject(misMatchObj); // for debugging and click-tracking

      ctx.fillStyle = _style["default"].BASE_COLORS[base];
      var y = yScale(countSoFar);
      ctx.fillRect(barX1,
      y,
      Math.max(1, barX2 - barX1), // min width of 1px
      yScale(countSoFar + count) - y);
      countSoFar += count;

      ctx.popObject();
    });
    ctx.popObject();
  });
}var

CoverageTrack = /*#__PURE__*/function (_React$Component) {_inherits(CoverageTrack, _React$Component);var _super2 = _createSuper(CoverageTrack);

  // no state, used to make flow happy







  function CoverageTrack(props) {var _this2;_classCallCheck(this, CoverageTrack);
    _this2 = _super2.call(this, props);
    _this2.ref = /*#__PURE__*/_react["default"].createRef();return _this2;
  }_createClass(CoverageTrack, [{ key: "render", value:

    function render() {
      return /*#__PURE__*/_react["default"].createElement("canvas", { ref: this.ref, onClick: this.handleClick.bind(this) });
    } }, { key: "getScale", value:

    function getScale() {
      return _d3utils["default"].getTrackScale(this.props.range, this.props.width);
    } }, { key: "componentDidMount", value:

    function componentDidMount() {var _this3 = this;
      this.cache = new _CoverageCache["default"](this.props.referenceSource);
      this.tiles = new CoverageTiledCanvas(this.cache, this.props.height, this.props.options);

      this.props.source.on('newdata', function (range) {
        var oldMax = _this3.tiles.maxCoverage;
        _this3.props.source.getFeaturesInRange(range).
        forEach(function (read) {return _this3.cache.addItem(read);});
        _this3.tiles.maxCoverage = _this3.cache.maxCoverageForRange(range);

        if (oldMax != _this3.tiles.maxCoverage) {
          _this3.tiles.invalidateAll();
        } else {
          _this3.tiles.invalidateRange(range);
        }
        _this3.visualizeCoverage();
      });

      this.props.referenceSource.on('newdata', function (range) {
        _this3.cache.updateMismatches(range);
        _this3.tiles.invalidateRange(range);
        _this3.visualizeCoverage();
      });
    } }, { key: "componentDidUpdate", value:

    function componentDidUpdate(prevProps, prevState) {
      if (!(0, _shallowEquals["default"])(this.props, prevProps) ||
      !(0, _shallowEquals["default"])(this.state, prevState)) {
        if (this.props.height != prevProps.height ||
        this.props.options != prevProps.options) {
          this.tiles.maxCoverage = this.cache.maxCoverageForRange(_ContigInterval["default"].fromGenomeRange(this.props.range));
          this.tiles.update(this.props.height, this.props.options);
          this.tiles.invalidateAll();
        }
        this.visualizeCoverage();
      }
    } }, { key: "getContext", value:

    function getContext() {
      var canvas = this.ref.current;
      // The typecast through `any` is because getContext could return a WebGL context.
      var ctx = canvas.getContext('2d');
      return ctx;
    }

    // Draw three ticks on the left to set the scale for the user
  }, { key: "renderTicks", value: function renderTicks(ctx, yScale) {
      var axisMax = yScale.domain()[0];
      [0, Math.round(axisMax / 2), axisMax].forEach(function (tick) {
        // Draw a line indicating the tick
        ctx.pushObject({ value: tick, type: 'tick' });
        var tickPosY = Math.round(yScale(tick));
        ctx.strokeStyle = _style["default"].COVERAGE_FONT_COLOR;
        _canvasUtils["default"].drawLine(ctx, 0, tickPosY, _style["default"].COVERAGE_TICK_LENGTH, tickPosY);
        ctx.popObject();

        var tickLabel = tick + 'X';
        ctx.pushObject({ value: tick, label: tickLabel, type: 'label' });
        // Now print the coverage information
        ctx.font = _style["default"].COVERAGE_FONT_STYLE;
        var textPosX = _style["default"].COVERAGE_TICK_LENGTH + _style["default"].COVERAGE_TEXT_PADDING,
        textPosY = tickPosY + _style["default"].COVERAGE_TEXT_Y_OFFSET;
        // The stroke creates a border around the text to make it legible over the bars.
        ctx.strokeStyle = 'white';
        ctx.lineWidth = 2;
        ctx.strokeText(tickLabel, textPosX, textPosY);
        ctx.lineWidth = 1;
        ctx.fillStyle = _style["default"].COVERAGE_FONT_COLOR;
        ctx.fillText(tickLabel, textPosX, textPosY);
        ctx.popObject();
      });
    } }, { key: "visualizeCoverage", value:

    function visualizeCoverage() {
      var canvas = this.ref.current;
      var width = this.props.width,
      height = this.props.height,
      range = _ContigInterval["default"].fromGenomeRange(this.props.range);

      // Hold off until height & width are known.
      if (width === 0) return;
      _d3utils["default"].sizeCanvas(canvas, width, height);

      var ctx = _dataCanvas["default"].getDataContext(this.getContext());
      ctx.save();
      ctx.reset();
      ctx.clearRect(0, 0, ctx.canvas.width, ctx.canvas.height);

      var yScale = this.tiles.yScaleForRef(10, 10);

      this.tiles.renderToScreen(ctx, range, this.getScale());
      this.renderTicks(ctx, yScale);

      ctx.restore();
    } }, { key: "handleClick", value:

    function handleClick(reactEvent) {
      var ev = reactEvent.nativeEvent,
      x = ev.offsetX;

      // It's simple to figure out which position was clicked using the x-scale.
      // No need to render the scene to determine what was clicked.
      var range = _ContigInterval["default"].fromGenomeRange(this.props.range),
      xScale = this.getScale(),
      bins = this.cache.binsForRef(range.contig),
      pos = Math.floor(xScale.invert(x)) - 1,
      bin = bins[pos];

      var alert = window.alert || console.log;
      if (bin) {
        var mmCount = bin.mismatches ? _underscore["default"].reduce(bin.mismatches, function (a, b) {return a + b;}) : 0;
        var ref = bin.ref || this.props.referenceSource.getRangeAsString(
        { contig: range.contig, start: pos, stop: pos });

        // Construct a JSON object to show the user.
        var messageObject = _underscore["default"].extend(
        {
          'position': range.contig + ':' + (1 + pos),
          'read depth': bin.count },

        bin.mismatches);
        messageObject[ref] = bin.count - mmCount;
        alert(JSON.stringify(messageObject, null, '  '));
      }
    } }]);return CoverageTrack;}(_react["default"].Component);


CoverageTrack.displayName = 'coverage';
CoverageTrack.defaultOptions = {
  // Color the reference base in the bar chart when the Variant Allele Fraction
  // exceeds this amount. When there are >=2 agreeing mismatches, they are
  // always rendered. But for mismatches below this threshold, the reference is
  // not colored in the bar chart. This draws attention to high-VAF mismatches.
  vafColorThreshold: 0.2,
  color: _style["default"].DEFAULT_COLORPICKER };


CoverageTrack.getOptionsMenu = function (options) {
  return [
  { key: 'pick-color', label: 'Change track color', color: options.color }];

};

CoverageTrack.handleSelectOption = function (item, oldOptions) {
  var opts = _underscore["default"].clone(oldOptions);
  if (item.key == "pick-color") {
    // This is all handled by the menu. Do nothing.
    opts.color = item.color;
    return opts;
  }
  return oldOptions; // no change
};


module.exports = CoverageTrack;