/**
 * Visualization of features.
 * 
 */
'use strict';function _typeof(obj) {"@babel/helpers - typeof";if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {_typeof = function _typeof(obj) {return typeof obj;};} else {_typeof = function _typeof(obj) {return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;};}return _typeof(obj);}


var _feature = _interopRequireDefault(require("../data/feature"));
var _genericFeature = _interopRequireDefault(require("../data/genericFeature"));
var _GenericFeatureCache = require("./GenericFeatureCache");






var _react = _interopRequireDefault(require("react"));
var _shallowEquals = _interopRequireDefault(require("shallow-equals"));
var _underscore = _interopRequireDefault(require("underscore"));

var _d3utils = _interopRequireDefault(require("./d3utils"));
var _RemoteRequest = _interopRequireDefault(require("../RemoteRequest"));
var _ContigInterval = _interopRequireDefault(require("../ContigInterval"));
var _canvasUtils = _interopRequireDefault(require("./canvas-utils"));
var _TiledCanvas2 = _interopRequireDefault(require("./TiledCanvas"));
var _dataCanvas = _interopRequireDefault(require("data-canvas"));
var _style = _interopRequireDefault(require("../style"));

var _pileuputils = require("./pileuputils");function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}function _createClass(Constructor, protoProps, staticProps) {if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function");}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);}function _setPrototypeOf(o, p) {_setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {o.__proto__ = p;return o;};return _setPrototypeOf(o, p);}function _createSuper(Derived) {var hasNativeReflectConstruct = _isNativeReflectConstruct();return function _createSuperInternal() {var Super = _getPrototypeOf(Derived),result;if (hasNativeReflectConstruct) {var NewTarget = _getPrototypeOf(this).constructor;result = Reflect.construct(Super, arguments, NewTarget);} else {result = Super.apply(this, arguments);}return _possibleConstructorReturn(this, result);};}function _possibleConstructorReturn(self, call) {if (call && (_typeof(call) === "object" || typeof call === "function")) {return call;}return _assertThisInitialized(self);}function _assertThisInitialized(self) {if (self === void 0) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return self;}function _isNativeReflectConstruct() {if (typeof Reflect === "undefined" || !Reflect.construct) return false;if (Reflect.construct.sham) return false;if (typeof Proxy === "function") return true;try {Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));return true;} catch (e) {return false;}}function _getPrototypeOf(o) {_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {return o.__proto__ || Object.getPrototypeOf(o);};return _getPrototypeOf(o);}var


FeatureTiledCanvas = /*#__PURE__*/function (_TiledCanvas) {_inherits(FeatureTiledCanvas, _TiledCanvas);var _super = _createSuper(FeatureTiledCanvas);




  function FeatureTiledCanvas(source, cache, options) {var _this;_classCallCheck(this, FeatureTiledCanvas);
    _this = _super.call(this);
    _this.source = source;
    _this.cache = cache;
    _this.options = options;return _this;
  }_createClass(FeatureTiledCanvas, [{ key: "update", value:

    function update(newOptions) {
      this.options = newOptions;
    } }, { key: "heightForRef", value:

    function heightForRef(ref) {
      return Math.max(this.cache.pileupHeightForRef(ref), 1) * (
      _style["default"].READ_HEIGHT + _style["default"].READ_SPACING);
    } }, { key: "render", value:

    function render(ctx,
    scale,
    range,
    originalRange,
    resolution) {var _this2 = this;
      var relaxedRange =
      new _ContigInterval["default"](range.contig, range.start() - 1, range.stop() + 1);
      // get features and put in cache
      var features = this.source.getFeaturesInRange(relaxedRange, resolution);
      features.forEach(function (f) {return _this2.cache.addFeature(new _genericFeature["default"](f.id, f.position, f));});

      // get visual features with assigned rows
      var vFeatures = this.cache.getGroupsOverlapping(relaxedRange);
      renderFeatures(ctx, scale, relaxedRange, vFeatures, this.options);
    } }]);return FeatureTiledCanvas;}(_TiledCanvas2["default"]);


// Draw features
function renderFeatures(ctx,
scale,
range,
vFeatures,
options) {

  ctx.font = "".concat(_style["default"].GENE_FONT_SIZE, "px ").concat(_style["default"].GENE_FONT);
  ctx.textAlign = 'center';

  vFeatures.forEach(function (vFeature) {
    var feature = vFeature.items[0].gFeature;
    if (!vFeature.span.intersects(range)) return;
    ctx.pushObject(feature);
    ctx.lineWidth = 1;

    // Create transparency value based on score. Score of <= 200 is the same transparency.
    var alphaScore = Math.max(feature.score / 1000.0, 0.2);
    options.color.rgb.a = alphaScore;
    ctx.fillStyle = "rgba(".concat(options.color.rgb.r, ", ").concat(options.color.rgb.g, ", ").concat(options.color.rgb.b, ", ").concat(options.color.rgb.a, ")");
    var x = Math.round(scale(vFeature.span.start()));
    var width = Math.ceil(scale(vFeature.span.stop()) - scale(vFeature.span.start()));
    // if collapse mode, render everything in a single row
    var y = options.collapse ? (0, _pileuputils.yForRow)(0) : (0, _pileuputils.yForRow)(vFeature.row);
    ctx.fillRect(x - 0.5, y, width, _style["default"].READ_HEIGHT);
    ctx.popObject();
  });
}var

FeatureTrack = /*#__PURE__*/function (_React$Component) {_inherits(FeatureTrack, _React$Component);var _super2 = _createSuper(FeatureTrack);









  function FeatureTrack(props) {var _this3;_classCallCheck(this, FeatureTrack);
    _this3 = _super2.call(this, props);
    _this3.ref = /*#__PURE__*/_react["default"].createRef();
    _this3.state = {
      networkStatus: null };return _this3;

  }_createClass(FeatureTrack, [{ key: "render", value:

    function render() {
      // These styles allow vertical scrolling to see the full pileup.
      // Adding a vertical scrollbar shrinks the visible area, but we have to act
      // as though it doesn't, since adjusting the scale would put it out of sync
      // with other tracks.
      var containerStyles = {
        'height': '100%' };


      var statusEl = null,
      networkStatus = this.state.networkStatus;
      if (networkStatus) {
        statusEl = /*#__PURE__*/
        _react["default"].createElement("div", { className: "network-status-small" }, /*#__PURE__*/
        _react["default"].createElement("div", { className: "network-status-message-small" }, "Loading features\u2026"));




      }
      var rangeLength = this.props.range.stop - this.props.range.start;
      // If range is too large, do not render 'canvas'
      if (rangeLength > _RemoteRequest["default"].MONSTER_REQUEST) {
        return /*#__PURE__*/(
          _react["default"].createElement("div", null, /*#__PURE__*/
          _react["default"].createElement("div", { className: "center" }, "Zoom in to see features"), /*#__PURE__*/


          _react["default"].createElement("canvas", { onClick: this.handleClick.bind(this) })));


      } else {
        return /*#__PURE__*/(
          _react["default"].createElement("div", null,
          statusEl, /*#__PURE__*/
          _react["default"].createElement("div", { style: containerStyles }, /*#__PURE__*/
          _react["default"].createElement("canvas", { ref: this.ref, onClick: this.handleClick.bind(this) }))));



      }
    } }, { key: "componentDidMount", value:

    function componentDidMount() {var _this4 = this;
      this.cache = new _GenericFeatureCache.GenericFeatureCache(this.props.referenceSource);
      this.tiles = new FeatureTiledCanvas(this.props.source, this.cache, this.props.options);

      // Visualize new reference data as it comes in from the network.
      this.props.source.on('newdata', function (range) {
        _this4.tiles.invalidateRange(range);
        _this4.updateVisualization();
      });
      this.props.referenceSource.on('newdata', function (range) {
        _this4.tiles.invalidateRange(range);
        _this4.updateVisualization();
      });
      this.props.source.on('networkprogress', function (e) {
        _this4.setState({ networkStatus: e });
      });
      this.props.source.on('networkdone', function (e) {
        _this4.setState({ networkStatus: null });
      });

      this.updateVisualization();
    } }, { key: "getScale", value:

    function getScale() {
      return _d3utils["default"].getTrackScale(this.props.range, this.props.width);
    } }, { key: "componentDidUpdate", value:

    function componentDidUpdate(prevProps, prevState) {
      var shouldUpdate = false;
      if (this.props.options != prevProps.options) {
        this.handleOptionsChange(prevProps.options);
        shouldUpdate = true;
      }

      if (!(0, _shallowEquals["default"])(this.props, prevProps) ||
      !(0, _shallowEquals["default"])(this.state, prevState) ||
      shouldUpdate) {
        this.tiles.update(this.props.options);
        this.tiles.invalidateAll();
        this.updateVisualization();
      }
    } }, { key: "handleOptionsChange", value:

    function handleOptionsChange(oldOpts) {
      this.tiles.invalidateAll();
      if (oldOpts.collapse != this.props.options.collapse) {
        this.tiles.update(this.props.options);
        this.tiles.invalidateAll();
        this.updateVisualization();
      } else if (oldOpts.color != this.props.options.color) {
        this.tiles.update(this.props.options);
        this.tiles.invalidateAll();
        this.updateVisualization();
      }
    } }, { key: "updateVisualization", value:

    function updateVisualization() {
      var canvas = this.ref.current;
      var width = this.props.width,
      genomeRange = this.props.range;

      var range = new _ContigInterval["default"](genomeRange.contig, genomeRange.start, genomeRange.stop);

      // Hold off until height & width are known.
      if (width === 0 || typeof canvas == 'undefined') return;

      var ctx = _dataCanvas["default"].getDataContext(_canvasUtils["default"].getContext(canvas));

      ctx.reset();
      ctx.clearRect(0, 0, ctx.canvas.width, ctx.canvas.height);

      // get parent of canvas
      // The typecasts through `any` are to fool flow.
      var parent = _d3utils["default"].findParent(canvas, "features");

      // Height can only be computed after the pileup has been updated.
      var height = _style["default"].READ_HEIGHT + _style["default"].READ_SPACING;
      if (!this.props.options.collapse) {
        height = this.tiles.heightForRef(this.props.range.contig);
      }

      // resize height for device
      height = _d3utils["default"].heightForCanvas(canvas, height);

      // set height for parent div to include all features
      if (parent) parent.style.height = "".concat(height, "px");

      _d3utils["default"].sizeCanvas(canvas, width, height);

      this.tiles.renderToScreen(ctx, range, this.getScale());
    } }, { key: "handleClick", value:

    function handleClick(reactEvent) {
      var ratio = window.devicePixelRatio;
      var ev = reactEvent.nativeEvent,
      x = ev.offsetX, // resize offset to canvas size
      y = ev.offsetY / ratio;

      var ctx = _canvasUtils["default"].getContext(this.ref.current);
      var trackingCtx = new _dataCanvas["default"].ClickTrackingContext(ctx, x, y);

      var genomeRange = this.props.range,
      // allow some buffering so click isn't so sensitive
      range = new _ContigInterval["default"](genomeRange.contig, genomeRange.start - 1, genomeRange.stop + 1),
      scale = this.getScale(),
      vFeatures = this.cache.getGroupsOverlapping(range);

      renderFeatures(trackingCtx, scale, range, vFeatures, this.props.options);
      var feature = _underscore["default"].find(trackingCtx.hits[0], function (hit) {return hit;});

      if (feature) {
        //user provided function for displaying popup
        if (typeof this.props.options.onFeatureClicked === "function") {
          this.props.options.onFeatureClicked(feature);
        } else {
          var alert = window.alert || console.log;
          // Construct a JSON object to show the user.
          var messageObject = _underscore["default"].extend(
          {
            'id': feature.id,
            'range': "".concat(feature.position.contig, ":").concat(feature.position.start(), "-").concat(feature.position.stop()),
            'score': feature.score });

          alert(JSON.stringify(messageObject, null, '  '));
        }
      }
    } }]);return FeatureTrack;}(_react["default"].Component);


FeatureTrack.displayName = 'features';

FeatureTrack.defaultOptions = {
  collapse: false,
  color: _style["default"].DEFAULT_COLORPICKER };


FeatureTrack.getOptionsMenu = function (options) {
  return [
  { key: 'collapse', label: 'Collapse track', checked: options.collapse },
  { key: 'pick-color', label: 'Change track color', color: options.color }];

};

FeatureTrack.handleSelectOption = function (item, oldOptions) {
  var opts = _underscore["default"].clone(oldOptions);
  if (item.key == 'collapse') {
    opts.collapse = !opts.collapse;
    return opts;
  } else if (item.key == "pick-color") {
    // This is all handled by the menu. Do nothing.
    opts.color = item.color;
    return opts;
  }
  return oldOptions; // no change
};

module.exports = FeatureTrack;