/**
 * Data management for FeatureTrack.
 *
 * This class groups features and piles them up.
 *
 * 
 */
'use strict';function _typeof(obj) {"@babel/helpers - typeof";if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {_typeof = function _typeof(obj) {return typeof obj;};} else {_typeof = function _typeof(obj) {return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;};}return _typeof(obj);}

var _underscore = _interopRequireDefault(require("underscore"));


var _genericFeature = _interopRequireDefault(require("../data/genericFeature.js"));
var _Interval = _interopRequireDefault(require("../Interval"));

var _pileuputils = require("./pileuputils");

var _AbstractCache2 = _interopRequireDefault(require("./AbstractCache"));function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}function _createClass(Constructor, protoProps, staticProps) {if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function");}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);}function _setPrototypeOf(o, p) {_setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {o.__proto__ = p;return o;};return _setPrototypeOf(o, p);}function _createSuper(Derived) {var hasNativeReflectConstruct = _isNativeReflectConstruct();return function _createSuperInternal() {var Super = _getPrototypeOf(Derived),result;if (hasNativeReflectConstruct) {var NewTarget = _getPrototypeOf(this).constructor;result = Reflect.construct(Super, arguments, NewTarget);} else {result = Super.apply(this, arguments);}return _possibleConstructorReturn(this, result);};}function _possibleConstructorReturn(self, call) {if (call && (_typeof(call) === "object" || typeof call === "function")) {return call;}return _assertThisInitialized(self);}function _assertThisInitialized(self) {if (self === void 0) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return self;}function _isNativeReflectConstruct() {if (typeof Reflect === "undefined" || !Reflect.construct) return false;if (Reflect.construct.sham) return false;if (typeof Proxy === "function") return true;try {Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));return true;} catch (e) {return false;}}function _getPrototypeOf(o) {_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {return o.__proto__ || Object.getPrototypeOf(o);};return _getPrototypeOf(o);}


// This class provides data management for the visualization
var GenericFeatureCache = /*#__PURE__*/function (_AbstractCache) {_inherits(GenericFeatureCache, _AbstractCache);var _super = _createSuper(GenericFeatureCache);
  // maps groupKey to VisualGroup




  function GenericFeatureCache(referenceSource) {_classCallCheck(this, GenericFeatureCache);return _super.call(this,
    referenceSource);
  }

  // name would make a good key, but features from different contigs
  // shouldn't be grouped visually. Hence we use feature name + contig.
  _createClass(GenericFeatureCache, [{ key: "groupKey", value: function groupKey(f) {
      return f.id || f.position.toString();
    }

    // Load a new feature into the visualization cache.
    // Calling this multiple times with the same feature is a no-op.
  }, { key: "addFeature", value: function addFeature(feature) {
      var key = this.groupKey(feature);

      if (!(key in this.groups)) {
        this.groups[key] = {
          key: key,
          span: feature.position,
          row: -1, // TBD
          insert: null,
          items: [] };

      }
      var group = this.groups[key];

      if (_underscore["default"].find(group.items, function (f) {return f.gFeature == feature.gFeature;})) {
        return; // we've already got it.
      }

      group.items.push(feature);

      if (!(feature.position.contig in this.refToPileup)) {
        this.refToPileup[feature.position.contig] = [];
      }
      var pileup = this.refToPileup[feature.position.contig];
      group.row = (0, _pileuputils.addToPileup)(group.span.interval, pileup);

    } }]);return GenericFeatureCache;}(_AbstractCache2["default"]);


module.exports = {
  GenericFeatureCache: GenericFeatureCache };