/**
 * Visualization of genotypes
 * 
 */
'use strict';function _typeof(obj) {"@babel/helpers - typeof";if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {_typeof = function _typeof(obj) {return typeof obj;};} else {_typeof = function _typeof(obj) {return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;};}return _typeof(obj);}






var _react = _interopRequireDefault(require("react"));
var _underscore = _interopRequireDefault(require("underscore"));


var _d3utils = _interopRequireDefault(require("./d3utils"));
var _shallowEquals = _interopRequireDefault(require("shallow-equals"));
var _ContigInterval = _interopRequireDefault(require("../ContigInterval"));
var _canvasUtils = _interopRequireDefault(require("./canvas-utils"));
var _TiledCanvas2 = _interopRequireDefault(require("./TiledCanvas"));
var _dataCanvas = _interopRequireDefault(require("data-canvas"));
var _style = _interopRequireDefault(require("../style"));
var _utils = _interopRequireDefault(require("../utils"));function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}function _createClass(Constructor, protoProps, staticProps) {if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function");}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);}function _setPrototypeOf(o, p) {_setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {o.__proto__ = p;return o;};return _setPrototypeOf(o, p);}function _createSuper(Derived) {var hasNativeReflectConstruct = _isNativeReflectConstruct();return function _createSuperInternal() {var Super = _getPrototypeOf(Derived),result;if (hasNativeReflectConstruct) {var NewTarget = _getPrototypeOf(this).constructor;result = Reflect.construct(Super, arguments, NewTarget);} else {result = Super.apply(this, arguments);}return _possibleConstructorReturn(this, result);};}function _possibleConstructorReturn(self, call) {if (call && (_typeof(call) === "object" || typeof call === "function")) {return call;}return _assertThisInitialized(self);}function _assertThisInitialized(self) {if (self === void 0) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return self;}function _isNativeReflectConstruct() {if (typeof Reflect === "undefined" || !Reflect.construct) return false;if (Reflect.construct.sham) return false;if (typeof Proxy === "function") return true;try {Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));return true;} catch (e) {return false;}}function _getPrototypeOf(o) {_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {return o.__proto__ || Object.getPrototypeOf(o);};return _getPrototypeOf(o);}


var MONSTER_REQUEST = 10000;
var LABEL_WIDTH = 100;var

GenotypeTiledCanvas = /*#__PURE__*/function (_TiledCanvas) {_inherits(GenotypeTiledCanvas, _TiledCanvas);var _super = _createSuper(GenotypeTiledCanvas);




  function GenotypeTiledCanvas(source, callSetNames, options) {var _this;_classCallCheck(this, GenotypeTiledCanvas);
    _this = _super.call(this);
    _this.source = source;
    _this.options = options;
    _this.callSetNames = callSetNames;return _this;
  }_createClass(GenotypeTiledCanvas, [{ key: "update", value:

    function update(newOptions) {
      this.options = newOptions;
    } }, { key: "heightForRef", value:

    function heightForRef(ref) {
      return yForRow(this.callSetNames.length);
    } }, { key: "render", value:

    function render(ctx,
    scale,
    range,
    originalRange) {
      var relaxedRange =
      new _ContigInterval["default"](range.contig, range.start() - 1, range.stop() + 1);

      // relaxed range is just for this tile
      var vGenotypes = this.source.getGenotypesInRange(relaxedRange);
      renderGenotypes(ctx, scale, relaxedRange, vGenotypes, this.callSetNames);
    } }]);return GenotypeTiledCanvas;}(_TiledCanvas2["default"]);

// Draw genotypes
function renderGenotypes(ctx,
scale,
range,
vcs,
callSetNames) {
  // draw genotypes
  vcs.forEach(function (vc) {
    var variant = vc.variant;
    ctx.pushObject(variant);

    var x = Math.round(scale(variant.position));
    var width = Math.max(1, Math.round(scale(variant.position + 1) - scale(variant.position)));
    vc.calls.forEach(function (call) {
      var y = yForRow(callSetNames.indexOf(call.callSetName));
      var callSum = call.genotype.reduce(function (a, b) {return a + b;}, 0);
      // do not display 0,0 calls
      if (callSum > 0) {
        ctx.fillStyle = callSum == 1 ? _style["default"].GENOTYPE_FILL_HET : _style["default"].GENOTYPE_FILL_HOM;
        ctx.strokeStyle = ctx.fillStyle;
        ctx.fillRect(x - 0.2, y, width, _style["default"].GENOTYPE_HEIGHT);
        ctx.strokeRect(x - 0.2, y, width, _style["default"].GENOTYPE_HEIGHT);
      }
    });
    ctx.popObject();
  });
}

function yForRow(row) {
  return row * (_style["default"].GENOTYPE_HEIGHT + _style["default"].GENOTYPE_SPACING);
}var

GenotypeTrack = /*#__PURE__*/function (_React$Component) {_inherits(GenotypeTrack, _React$Component);var _super2 = _createSuper(GenotypeTrack);







  function GenotypeTrack(props) {var _this2;_classCallCheck(this, GenotypeTrack);
    _this2 = _super2.call(this, props);
    _this2.labelRef = /*#__PURE__*/_react["default"].createRef();
    _this2.canvasRef = /*#__PURE__*/_react["default"].createRef();
    _this2.callSetNames = [];
    _this2.state = {
      networkStatus: null };

    props.source.getCallNames().then(function (samples) {
      _this2.callSetNames = samples;
      _this2.tiles.callSetNames = samples;
      _this2.tiles.invalidateAll();
      _this2.updateVisualization();
    });return _this2;
  }_createClass(GenotypeTrack, [{ key: "render", value:

    function render() {
      // These styles allow vertical scrolling to see the full pileup.
      // Adding a vertical scrollbar shrinks the visible area, but we have to act
      // as though it doesn't, since adjusting the scale would put it out of sync
      // with other tracks.
      var containerStyles = {
        'height': '100%' };


      var labelStyles = {
        'float': 'left',
        'overflow': 'hidden',
        'width:': "".concat(LABEL_WIDTH, "px") };


      var canvasStyles = {
        'overflow': 'hidden' };


      var statusEl = null,
      networkStatus = this.state.networkStatus;
      if (networkStatus) {
        statusEl = /*#__PURE__*/
        _react["default"].createElement("div", { className: "network-status-small" }, /*#__PURE__*/
        _react["default"].createElement("div", { className: "network-status-message-small" }, "Loading Genotypes\u2026"));




      }
      var rangeLength = this.props.range.stop - this.props.range.start;
      // If range is too large, do not render 'canvas'
      if (rangeLength >= MONSTER_REQUEST) {
        return /*#__PURE__*/(
          _react["default"].createElement("div", null, /*#__PURE__*/
          _react["default"].createElement("div", { className: "center" }, "Zoom in to see genotypes"), /*#__PURE__*/


          _react["default"].createElement("canvas", { onClick: this.handleClick.bind(this) })));


      } else {
        return /*#__PURE__*/(
          _react["default"].createElement("div", null,
          statusEl, /*#__PURE__*/
          _react["default"].createElement("div", { style: containerStyles }, /*#__PURE__*/
          _react["default"].createElement("div", { className: "genotypeLabels", style: labelStyles }, /*#__PURE__*/_react["default"].createElement("canvas", { ref: this.labelRef })), /*#__PURE__*/
          _react["default"].createElement("div", { className: "genotypeRows", style: canvasStyles }, /*#__PURE__*/_react["default"].createElement("canvas", { ref: this.canvasRef, onClick: this.handleClick.bind(this) })))));



      }
    } }, { key: "componentDidMount", value:

    function componentDidMount() {var _this3 = this;
      this.tiles = new GenotypeTiledCanvas(this.props.source,
      this.callSetNames, this.props.options);

      // Visualize new data as it comes in from the network.
      this.props.source.on('newdata', function (range) {
        _this3.tiles.invalidateRange(range);
        _this3.updateVisualization();
      });
      this.props.source.on('networkprogress', function (e) {
        _this3.setState({ networkStatus: e });
      });
      this.props.source.on('networkdone', function (e) {
        _this3.setState({ networkStatus: null });
      });

      this.updateVisualization();
    } }, { key: "getScale", value:

    function getScale() {
      return _d3utils["default"].getTrackScale(this.props.range, this.props.width - LABEL_WIDTH);
    } }, { key: "componentDidUpdate", value:

    function componentDidUpdate(prevProps, prevState) {
      if (!(0, _shallowEquals["default"])(prevProps, this.props) ||
      !(0, _shallowEquals["default"])(prevState, this.state)) {
        this.tiles.update(this.props.options);
        this.tiles.invalidateAll();
        this.updateVisualization();
      }
    }

    // draws genotype lines to visually separate genotype rows
  }, { key: "drawLines", value: function drawLines(ctx) {var _this4 = this;
      var width = this.props.width;

      // draw background for each row
      if (this.callSetNames !== null) {
        ctx.font = "9px Arial";
        this.callSetNames.forEach(function (sampleId) {
          ctx.pushObject(sampleId);
          var y = yForRow(_this4.callSetNames.indexOf(sampleId));
          ctx.fillStyle = _style["default"].BACKGROUND_FILL;
          ctx.fillRect(0, y, width, _style["default"].GENOTYPE_HEIGHT);
          ctx.popObject();
        });
      }
    }

    // draws sample names on side bar. This needs to be only rendered once.
  }, { key: "drawLabels", value: function drawLabels() {var _this5 = this;
      // if already drawn, return
      var labelCanvas = this.labelRef.current;
      var width = this.props.width;

      // Hold off until height & width are known.
      if (width === 0 || typeof labelCanvas == 'undefined') return;

      var height = yForRow(this.callSetNames.length);


      // only render once on load.
      if (labelCanvas.clientHeight != height) {
        var labelCtx = _dataCanvas["default"].getDataContext(_canvasUtils["default"].getContext(labelCanvas));
        _d3utils["default"].sizeCanvas(labelCanvas, LABEL_WIDTH, height);

        // draw label for each row
        if (this.callSetNames !== null) {
          labelCtx.font = "9px Arial";
          this.callSetNames.forEach(function (sampleId) {
            labelCtx.pushObject(sampleId);
            var y = yForRow(_this5.callSetNames.indexOf(sampleId));
            labelCtx.fillStyle = "black";
            labelCtx.fillText(sampleId, 0, y + _style["default"].GENOTYPE_HEIGHT);
            labelCtx.popObject();
          });
        }
      }
    } }, { key: "updateVisualization", value:

    function updateVisualization() {
      var canvas = this.canvasRef.current;
      var width = this.props.width;

      // Hold off until height & width are known.
      if (width === 0 || typeof canvas == 'undefined') return;

      var height = yForRow(this.callSetNames.length);
      _d3utils["default"].sizeCanvas(canvas, width - LABEL_WIDTH, height);

      var ctx = _dataCanvas["default"].getDataContext(_canvasUtils["default"].getContext(canvas));
      this.drawLabels();
      this.renderScene(ctx);
    } }, { key: "renderScene", value:

    function renderScene(ctx) {
      var range = this.props.range,
      interval = new _ContigInterval["default"](range.contig, range.start, range.stop),
      scale = this.getScale();

      ctx.reset();
      ctx.clearRect(0, 0, ctx.canvas.width, ctx.canvas.height);

      // render lines after rectangle has been cleared
      this.drawLines(ctx);

      this.tiles.renderToScreen(ctx, interval, scale);
      ctx.restore();
    } }, { key: "handleClick", value:

    function handleClick(reactEvent) {
      var ev = reactEvent.nativeEvent,
      x = ev.offsetX;

      var genomeRange = this.props.range,
      // allow some buffering so click isn't so sensitive
      range = new _ContigInterval["default"](genomeRange.contig, genomeRange.start - 1, genomeRange.stop + 1),
      scale = this.getScale(),
      // leave padding of 2px to reduce click specificity
      clickStart = Math.floor(scale.invert(x)) - 2,
      clickEnd = clickStart + 2,
      // If click-tracking gets slow, this range could be narrowed to one
      // closer to the click coordinate, rather than the whole visible range.
      vGenotypes = this.props.source.getGenotypesInRange(range);

      var genotype = _underscore["default"].find(vGenotypes, function (f) {return _utils["default"].tupleRangeOverlaps([[f.variant.position], [f.variant.position + 1]], [[clickStart], [clickEnd]]);});
      var alert = window.alert || console.log;
      if (genotype) {
        var variantString = "variant: ".concat(JSON.stringify(genotype.variant));
        var callSetNames = genotype.calls.map(function (r) {return r.callSetName;});
        var samples = "samples with variant: ".concat(JSON.stringify(callSetNames));
        alert("".concat(variantString, "\n").concat(samples));
      }
    } }]);return GenotypeTrack;}(_react["default"].Component);


GenotypeTrack.displayName = 'genotypes';

module.exports = GenotypeTrack;