/**
 * A track which shows an idiogram.
 *
 * 
 */
'use strict';function _typeof(obj) {"@babel/helpers - typeof";if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {_typeof = function _typeof(obj) {return typeof obj;};} else {_typeof = function _typeof(obj) {return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;};}return _typeof(obj);}




var _react = _interopRequireDefault(require("react"));
var _ContigInterval = _interopRequireDefault(require("../ContigInterval"));
var _chromosome = _interopRequireDefault(require("../data/chromosome"));
var _canvasUtils = _interopRequireDefault(require("./canvas-utils"));
var _dataCanvas = _interopRequireDefault(require("data-canvas"));
var _style = _interopRequireDefault(require("../style"));

var _shallowEquals = _interopRequireDefault(require("shallow-equals"));
var _d3utils = _interopRequireDefault(require("./d3utils"));
var _underscore = _interopRequireDefault(require("underscore"));

var _genericFeature = _interopRequireDefault(require("../data/genericFeature"));
var _GenericFeatureCache = require("./GenericFeatureCache");function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}function _createClass(Constructor, protoProps, staticProps) {if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function");}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);}function _setPrototypeOf(o, p) {_setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {o.__proto__ = p;return o;};return _setPrototypeOf(o, p);}function _createSuper(Derived) {var hasNativeReflectConstruct = _isNativeReflectConstruct();return function _createSuperInternal() {var Super = _getPrototypeOf(Derived),result;if (hasNativeReflectConstruct) {var NewTarget = _getPrototypeOf(this).constructor;result = Reflect.construct(Super, arguments, NewTarget);} else {result = Super.apply(this, arguments);}return _possibleConstructorReturn(this, result);};}function _possibleConstructorReturn(self, call) {if (call && (_typeof(call) === "object" || typeof call === "function")) {return call;}return _assertThisInitialized(self);}function _assertThisInitialized(self) {if (self === void 0) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return self;}function _isNativeReflectConstruct() {if (typeof Reflect === "undefined" || !Reflect.construct) return false;if (Reflect.construct.sham) return false;if (typeof Proxy === "function") return true;try {Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));return true;} catch (e) {return false;}}function _getPrototypeOf(o) {_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {return o.__proto__ || Object.getPrototypeOf(o);};return _getPrototypeOf(o);}

function gstainFiller(d) {
  var stain = _style["default"].IDIOGRAM_COLORS[d.value];
  if (stain === undefined) {
    return 'white';
  } else {
    return stain;
  }
}var

IdiogramTrack = /*#__PURE__*/function (_React$Component) {_inherits(IdiogramTrack, _React$Component);var _super = _createSuper(IdiogramTrack);





  function IdiogramTrack(props) {var _this;_classCallCheck(this, IdiogramTrack);
    _this = _super.call(this, props);
    _this.ref = /*#__PURE__*/_react["default"].createRef();
    _this.state = {
      networkStatus: null };return _this;

  }_createClass(IdiogramTrack, [{ key: "render", value:

    function render() {
      return /*#__PURE__*/_react["default"].createElement("canvas", { ref: this.ref });
    } }, { key: "componentDidMount", value:

    function componentDidMount() {var _this2 = this;
      this.cache = new _GenericFeatureCache.GenericFeatureCache(this.props.referenceSource);
      // Visualize new reference data as it comes in from the network.
      this.props.source.on('newdata', function (range) {
        // add to generic cache
        var chrs = _this2.props.source.getFeaturesInRange(range);
        chrs.forEach(function (chr) {return _this2.cache.addFeature(new _genericFeature["default"](chr.name, chr.position, chr));});
        _this2.updateVisualization();
      });
      this.props.referenceSource.on('newdata', function (range) {
        _this2.updateVisualization();
      });
      this.props.source.on('networkprogress', function (e) {
        _this2.setState({ networkStatus: e });
      });
      this.props.source.on('networkdone', function (e) {
        _this2.setState({ networkStatus: null });
      });

      this.updateVisualization();
    } }, { key: "componentDidUpdate", value:

    function componentDidUpdate(prevProps, prevState) {
      if (!(0, _shallowEquals["default"])(this.props, prevProps) ||
      !(0, _shallowEquals["default"])(this.state, prevState)) {
        this.updateVisualization(prevProps);
      }
    } }, { key: "updateVisualization", value:

    function updateVisualization(prevProps) {
      var canvas = this.ref.current;var _this$props =
      this.props,width = _this$props.width,height = _this$props.height;

      var range = new _ContigInterval["default"](this.props.range.contig, this.props.range.start, this.props.range.stop);

      // Hold off until height & width are known.
      if (width === 0 || typeof canvas == 'undefined' || canvas == null) return;

      this.updateChromosome(canvas, height, width, range);
      this.updateChromosomeLocation(canvas, height, width, range);
    } }, { key: "updateChromosomeLocation", value:

    function updateChromosomeLocation(canvas, height, width, range) {
      var chrs = _underscore["default"].flatten(_underscore["default"].map(this.cache.getGroupsOverlapping(range),
      function (g) {return g.items;}));


      // Hold off until height & width are known.
      if (width === 0 || typeof canvas == 'undefined' || canvas == null) return;

      if (!chrs || chrs.length == 0) {
        return;
      }
      var chr = chrs[0];
      var ctx = _dataCanvas["default"].getDataContext(_canvasUtils["default"].getContext(canvas));

      var iv = { 'start': chr.position.start(),
        'stop': chr.position.stop() };
      var sc = _d3utils["default"].getTrackScale(iv, this.props.width);

      var viewWidth = Math.ceil(sc(range.stop()) - sc(range.start()));
      ctx.strokeStyle = 'red';
      ctx.strokeRect(sc(range.start()),
      _style["default"].IDIOGRAM_LINEWIDTH * 2,
      viewWidth,
      _style["default"].READ_HEIGHT);

      ctx.popObject();
    } }, { key: "updateChromosome", value:

    function updateChromosome(canvas, height, width, range) {var _this3 = this;

      // Hold off until height & width are known.
      if (width === 0 || typeof canvas == 'undefined' || canvas == null) return;

      _d3utils["default"].sizeCanvas(canvas, width, height);
      var ctx = _dataCanvas["default"].getDataContext(_canvasUtils["default"].getContext(canvas));

      ctx.reset();
      ctx.clearRect(0, 0, ctx.canvas.width, ctx.canvas.height);

      height = _d3utils["default"].heightForCanvas(canvas, _style["default"].READ_HEIGHT);

      var chrs = _underscore["default"].flatten(_underscore["default"].map(this.cache.getGroupsOverlapping(range),
      function (g) {return g.items;}));

      chrs.forEach(function (chr) {
        var iv = { 'start': chr.position.start(),
          'stop': chr.position.stop() };
        // add bands
        var band_sc = _d3utils["default"].getTrackScale(iv, _this3.props.width);
        chr.gFeature.bands.forEach(function (band) {
          ctx.pushObject(band);
          var filler = gstainFiller(band);

          var width = Math.ceil(band_sc(band.end) - band_sc(band.start));
          var start = band_sc(band.start) + _style["default"].IDIOGRAM_LINEWIDTH;


          if (band.value == "acen") {
            ctx.fillStyle = 'red';
            ctx.beginPath();
            if (band.name.startsWith("p")) {
              ctx.moveTo(start + _style["default"].IDIOGRAM_LINEWIDTH, _style["default"].IDIOGRAM_LINEWIDTH * 2);
              ctx.lineTo(start + width, _style["default"].READ_HEIGHT / 2);
              ctx.lineTo(start + _style["default"].IDIOGRAM_LINEWIDTH, _style["default"].READ_HEIGHT + _style["default"].IDIOGRAM_LINEWIDTH);
              ctx.fill();
            } else {
              ctx.moveTo(start + _style["default"].IDIOGRAM_LINEWIDTH, _style["default"].READ_HEIGHT / 2);
              ctx.lineTo(start + width, _style["default"].IDIOGRAM_LINEWIDTH * 2);
              ctx.lineTo(start + width, _style["default"].READ_HEIGHT + _style["default"].IDIOGRAM_LINEWIDTH);
              ctx.fill();
            }
          } else {
            ctx.fillStyle = filler;
            ctx.strokeStyle = 'black';
            ctx.fillRect(start,
            _style["default"].IDIOGRAM_LINEWIDTH * 2,
            width,
            _style["default"].READ_HEIGHT);
            ctx.strokeRect(start,
            _style["default"].IDIOGRAM_LINEWIDTH * 2,
            width,
            _style["default"].READ_HEIGHT);
          }
          ctx.popObject();
        });
      });
    } }]);return IdiogramTrack;}(_react["default"].Component);



IdiogramTrack.displayName = 'idiogram';

module.exports = IdiogramTrack;