/**
 * A track which shows the location of the base in the middle of the view.
 * 
 */
'use strict';function _typeof(obj) {"@babel/helpers - typeof";if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {_typeof = function _typeof(obj) {return typeof obj;};} else {_typeof = function _typeof(obj) {return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;};}return _typeof(obj);}




var _react = _interopRequireDefault(require("react"));
var _EmptySource = _interopRequireDefault(require("../sources/EmptySource"));
var _canvasUtils = _interopRequireDefault(require("./canvas-utils"));
var _dataCanvas = _interopRequireDefault(require("data-canvas"));
var _style = _interopRequireDefault(require("../style"));
var _d3utils = _interopRequireDefault(require("./d3utils"));function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}function _createClass(Constructor, protoProps, staticProps) {if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function");}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);}function _setPrototypeOf(o, p) {_setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {o.__proto__ = p;return o;};return _setPrototypeOf(o, p);}function _createSuper(Derived) {var hasNativeReflectConstruct = _isNativeReflectConstruct();return function _createSuperInternal() {var Super = _getPrototypeOf(Derived),result;if (hasNativeReflectConstruct) {var NewTarget = _getPrototypeOf(this).constructor;result = Reflect.construct(Super, arguments, NewTarget);} else {result = Super.apply(this, arguments);}return _possibleConstructorReturn(this, result);};}function _possibleConstructorReturn(self, call) {if (call && (_typeof(call) === "object" || typeof call === "function")) {return call;}return _assertThisInitialized(self);}function _assertThisInitialized(self) {if (self === void 0) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return self;}function _isNativeReflectConstruct() {if (typeof Reflect === "undefined" || !Reflect.construct) return false;if (Reflect.construct.sham) return false;if (typeof Proxy === "function") return true;try {Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));return true;} catch (e) {return false;}}function _getPrototypeOf(o) {_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {return o.__proto__ || Object.getPrototypeOf(o);};return _getPrototypeOf(o);}var

LocationTrack = /*#__PURE__*/function (_React$Component) {_inherits(LocationTrack, _React$Component);var _super = _createSuper(LocationTrack);

  // state not used, here to make flow happy



  function LocationTrack(props) {var _this;_classCallCheck(this, LocationTrack);
    _this = _super.call(this, props);
    _this.ref = /*#__PURE__*/_react["default"].createRef();return _this;
  }_createClass(LocationTrack, [{ key: "getScale", value:

    function getScale() {
      return _d3utils["default"].getTrackScale(this.props.range, this.props.width);
    } }, { key: "render", value:

    function render() {
      return /*#__PURE__*/_react["default"].createElement("canvas", { ref: this.ref });
    } }, { key: "componentDidMount", value:

    function componentDidMount() {
      this.updateVisualization();
    } }, { key: "componentDidUpdate", value:

    function componentDidUpdate(prevProps, prevState) {
      this.updateVisualization();
    } }, { key: "updateVisualization", value:

    function updateVisualization() {
      var canvas = this.ref.current;var _this$props =
      this.props,range = _this$props.range,width = _this$props.width,height = _this$props.height,
      scale = this.getScale();

      if (canvas && canvas instanceof Element) {// check for getContext
        if (canvas instanceof HTMLCanvasElement) {// check for sizeCanvas
          _d3utils["default"].sizeCanvas(canvas, width, height);
        }
        var ctx = _dataCanvas["default"].getDataContext(_canvasUtils["default"].getContext(canvas));
        ctx.save();
        ctx.reset();
        ctx.clearRect(0, 0, ctx.canvas.width, ctx.canvas.height);

        var midPoint = Math.floor((range.stop + range.start) / 2),
        rightLineX = Math.round(scale(midPoint + 1)),
        leftLineX = Math.round(scale(midPoint));

        // Left line
        _canvasUtils["default"].drawLine(ctx, leftLineX - 0.5, 0, leftLineX - 0.5, height);

        // Right line
        _canvasUtils["default"].drawLine(ctx, rightLineX - 0.5, 0, rightLineX - 0.5, height);

        // Mid label
        var midY = height / 2;

        ctx.fillStyle = _style["default"].LOC_FONT_COLOR;
        ctx.font = _style["default"].LOC_FONT_STYLE;
        ctx.fillText(midPoint.toLocaleString() + ' bp',
        rightLineX + _style["default"].LOC_TICK_LENGTH + _style["default"].LOC_TEXT_PADDING,
        midY + _style["default"].LOC_TEXT_Y_OFFSET);

        // Connect label with the right line
        _canvasUtils["default"].drawLine(ctx, rightLineX - 0.5, midY - 0.5, rightLineX + _style["default"].LOC_TICK_LENGTH - 0.5, midY - 0.5);

        // clean up
        ctx.restore();
      } // end typecheck for canvas
    } }]);return LocationTrack;}(_react["default"].Component);


LocationTrack.displayName = 'location';
LocationTrack.defaultSource = _EmptySource["default"].create();

module.exports = LocationTrack;