/**
 * Visualization of variants
 * 
 */
'use strict';function _typeof(obj) {"@babel/helpers - typeof";if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {_typeof = function _typeof(obj) {return typeof obj;};} else {_typeof = function _typeof(obj) {return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;};}return _typeof(obj);}
var _types = require("../types");







var _react = _interopRequireDefault(require("react"));

var _d3utils = _interopRequireDefault(require("./d3utils"));
var _shallowEquals = _interopRequireDefault(require("shallow-equals"));
var _ContigInterval = _interopRequireDefault(require("../ContigInterval"));
var _canvasUtils = _interopRequireDefault(require("./canvas-utils"));
var _dataCanvas = _interopRequireDefault(require("data-canvas"));
var _style = _interopRequireDefault(require("../style"));function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}function _createClass(Constructor, protoProps, staticProps) {if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function");}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);}function _setPrototypeOf(o, p) {_setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {o.__proto__ = p;return o;};return _setPrototypeOf(o, p);}function _createSuper(Derived) {var hasNativeReflectConstruct = _isNativeReflectConstruct();return function _createSuperInternal() {var Super = _getPrototypeOf(Derived),result;if (hasNativeReflectConstruct) {var NewTarget = _getPrototypeOf(this).constructor;result = Reflect.construct(Super, arguments, NewTarget);} else {result = Super.apply(this, arguments);}return _possibleConstructorReturn(this, result);};}function _possibleConstructorReturn(self, call) {if (call && (_typeof(call) === "object" || typeof call === "function")) {return call;}return _assertThisInitialized(self);}function _assertThisInitialized(self) {if (self === void 0) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return self;}function _isNativeReflectConstruct() {if (typeof Reflect === "undefined" || !Reflect.construct) return false;if (Reflect.construct.sham) return false;if (typeof Proxy === "function") return true;try {Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));return true;} catch (e) {return false;}}function _getPrototypeOf(o) {_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {return o.__proto__ || Object.getPrototypeOf(o);};return _getPrototypeOf(o);}var

VariantTrack = /*#__PURE__*/function (_React$Component) {_inherits(VariantTrack, _React$Component);var _super = _createSuper(VariantTrack);




  function VariantTrack(props) {var _this;_classCallCheck(this, VariantTrack);
    _this = _super.call(this, props);
    _this.ref = /*#__PURE__*/_react["default"].createRef();return _this;
  }_createClass(VariantTrack, [{ key: "render", value:

    function render() {
      return /*#__PURE__*/_react["default"].createElement("canvas", { ref: this.ref, onClick: this.handleClick.bind(this) });
    } }, { key: "componentDidMount", value:

    function componentDidMount() {var _this2 = this;
      this.updateVisualization();

      this.props.source.on('newdata', function () {
        _this2.updateVisualization();
      });
    } }, { key: "getScale", value:

    function getScale() {
      return _d3utils["default"].getTrackScale(this.props.range, this.props.width);
    } }, { key: "componentDidUpdate", value:

    function componentDidUpdate(prevProps, prevState) {
      if (!(0, _shallowEquals["default"])(prevProps, this.props) ||
      !(0, _shallowEquals["default"])(prevState, this.state)) {
        this.updateVisualization();
      }
    } }, { key: "updateVisualization", value:

    function updateVisualization() {
      var canvas = this.ref.current;var _this$props =
      this.props,width = _this$props.width,height = _this$props.height;

      // Hold off until height & width are known.
      if (width === 0) return;

      if (canvas && canvas instanceof Element) {// check for getContext
        if (canvas instanceof HTMLCanvasElement) {// check for sizeCanvas
          _d3utils["default"].sizeCanvas(canvas, width, height);
        }
        var ctx = _canvasUtils["default"].getContext(canvas);
        var dtx = _dataCanvas["default"].getDataContext(ctx);
        this.renderScene(dtx);
      } else {
        throw new TypeError("canvas is not an Element");
      }
    } }, { key: "renderScene", value:

    function renderScene(ctx) {var _this3 = this;
      var range = this.props.range,
      interval = new _ContigInterval["default"](range.contig, range.start, range.stop),
      variants = this.props.source.getVariantsInRange(interval),
      scale = this.getScale(),
      height = this.props.height,
      y = height - _style["default"].VARIANT_HEIGHT - 1;

      ctx.clearRect(0, 0, ctx.canvas.width, ctx.canvas.height);
      ctx.reset();
      ctx.save();

      ctx.fillStyle = _style["default"].VARIANT_FILL;
      ctx.strokeStyle = _style["default"].VARIANT_STROKE;
      variants.forEach(function (variant) {
        var variantHeightRatio = 1.0;
        if (_this3.props.options.variantHeightByFrequency) {
          var frequency = null;
          if (_this3.props.options.allelFrequencyStrategy === undefined) {//default startegy
            frequency = variant.majorFrequency;
          } else if (_this3.props.options.allelFrequencyStrategy === _types.AllelFrequencyStrategy.Major) {
            frequency = variant.majorFrequency;
          } else if (_this3.props.options.allelFrequencyStrategy === _types.AllelFrequencyStrategy.Minor) {
            frequency = variant.minorFrequency;
          } else {
            console.log("Unknown AllelFrequencyStrategy: ", _this3.props.options.allelFrequencyStrategy);
          }
          if (frequency !== null && frequency !== undefined) {
            variantHeightRatio = frequency;
          }
        }
        var height = _style["default"].VARIANT_HEIGHT * variantHeightRatio;
        var variantY = y - 0.5 + _style["default"].VARIANT_HEIGHT - height;
        var variantX = Math.round(scale(variant.position)) - 0.5;
        var width = Math.max(1, Math.round(scale(variant.position + 1) - scale(variant.position)));
        ctx.pushObject(variant);

        ctx.fillRect(variantX, variantY, width, height);
        ctx.strokeRect(variantX, variantY, width, height);
        ctx.popObject();
      });

      ctx.restore();
    } }, { key: "handleClick", value:

    function handleClick(reactEvent) {
      var ev = reactEvent.nativeEvent,
      x = ev.offsetX,
      y = ev.offsetY;
      var canvas = this.ref.current;

      if (canvas == null) return;

      if (canvas && canvas instanceof Element) {
        var ctx = _canvasUtils["default"].getContext(canvas),
        trackingCtx = new _dataCanvas["default"].ClickTrackingContext(ctx, x, y);
        this.renderScene(trackingCtx);

        var variants = trackingCtx.hit;
        if (variants && variants.length > 0) {
          var data = [];
          for (var i = 0; i < variants.length; i++) {
            data.push({
              id: variants[i].id,
              vcfLine: variants[i].vcfLine,
              ref: variants[i].ref,
              alt: variants[i].alt });
          }
          //user provided function for displaying popup
          if (typeof this.props.options.onVariantClicked === "function") {
            this.props.options.onVariantClicked(data);
          } else {
            console.log("Variants clicked: ", data);
          }
        }
      } else {
        throw new TypeError("canvas is not an Element");
      }
    } }]);return VariantTrack;}(_react["default"].Component);


VariantTrack.displayName = 'variants';

module.exports = VariantTrack;