/**
 * This is a thin wrapper around RemoteFile which records all network requests.
 * 
 */

'use strict';function _typeof(obj) {"@babel/helpers - typeof";if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {_typeof = function _typeof(obj) {return typeof obj;};} else {_typeof = function _typeof(obj) {return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;};}return _typeof(obj);}



var _underscore = _interopRequireDefault(require("underscore"));

var _RemoteFile2 = _interopRequireDefault(require("../main/RemoteFile"));
var _Interval = _interopRequireDefault(require("../main/Interval"));function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}function _classCallCheck(instance, Constructor) {if (!(instance instanceof Constructor)) {throw new TypeError("Cannot call a class as a function");}}function _defineProperties(target, props) {for (var i = 0; i < props.length; i++) {var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);}}function _createClass(Constructor, protoProps, staticProps) {if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;}function _get(target, property, receiver) {if (typeof Reflect !== "undefined" && Reflect.get) {_get = Reflect.get;} else {_get = function _get(target, property, receiver) {var base = _superPropBase(target, property);if (!base) return;var desc = Object.getOwnPropertyDescriptor(base, property);if (desc.get) {return desc.get.call(receiver);}return desc.value;};}return _get(target, property, receiver || target);}function _superPropBase(object, property) {while (!Object.prototype.hasOwnProperty.call(object, property)) {object = _getPrototypeOf(object);if (object === null) break;}return object;}function _inherits(subClass, superClass) {if (typeof superClass !== "function" && superClass !== null) {throw new TypeError("Super expression must either be null or a function");}subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);}function _setPrototypeOf(o, p) {_setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {o.__proto__ = p;return o;};return _setPrototypeOf(o, p);}function _createSuper(Derived) {var hasNativeReflectConstruct = _isNativeReflectConstruct();return function _createSuperInternal() {var Super = _getPrototypeOf(Derived),result;if (hasNativeReflectConstruct) {var NewTarget = _getPrototypeOf(this).constructor;result = Reflect.construct(Super, arguments, NewTarget);} else {result = Super.apply(this, arguments);}return _possibleConstructorReturn(this, result);};}function _possibleConstructorReturn(self, call) {if (call && (_typeof(call) === "object" || typeof call === "function")) {return call;}return _assertThisInitialized(self);}function _assertThisInitialized(self) {if (self === void 0) {throw new ReferenceError("this hasn't been initialised - super() hasn't been called");}return self;}function _isNativeReflectConstruct() {if (typeof Reflect === "undefined" || !Reflect.construct) return false;if (Reflect.construct.sham) return false;if (typeof Proxy === "function") return true;try {Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));return true;} catch (e) {return false;}}function _getPrototypeOf(o) {_getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {return o.__proto__ || Object.getPrototypeOf(o);};return _getPrototypeOf(o);}var

RecordedRemoteFile = /*#__PURE__*/function (_RemoteFile) {_inherits(RecordedRemoteFile, _RemoteFile);var _super = _createSuper(RecordedRemoteFile);


  function RecordedRemoteFile(url) {var _this;_classCallCheck(this, RecordedRemoteFile);
    _this = _super.call(this, url);
    _this.requests = [];return _this;
  }_createClass(RecordedRemoteFile, [{ key: "getFromNetwork", value:

    function getFromNetwork(start, stop) {
      this.requests.push(new _Interval["default"](start, stop));
      return _get(_getPrototypeOf(RecordedRemoteFile.prototype), "getFromNetwork", this).call(this, start, stop);
    }

    // This sorts & coalesces overlapping requests to facilitate use of
    // scripts/generate_mapped_file.py.
  }, { key: "getRequests", value: function getRequests() {
      if (this.requests.length === 0) return [];

      var rs = _underscore["default"].sortBy(this.requests, function (x) {return x.start;});
      var blocks = [rs[0]];
      for (var i = 1; i < rs.length; i++) {
        var r = rs[i],
        last = blocks[blocks.length - 1];
        if (r.intersects(last)) {
          blocks[blocks.length - 1].stop = r.stop;
        } else {
          blocks.push(r);
        }
      }
      return blocks.map(function (iv) {return [iv.start, iv.stop];});
    } }]);return RecordedRemoteFile;}(_RemoteFile2["default"]);


module.exports = RecordedRemoteFile;