
'use strict';

var _chai = require("chai");

var _cytoBand = require("../../main/data/cytoBand");
var _ContigInterval = _interopRequireDefault(require("../../main/ContigInterval"));
var _RemoteFile = _interopRequireDefault(require("../../main/RemoteFile"));function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}

describe('CytoBand', function () {
  var remoteFile = new _RemoteFile["default"]('/test-data/cytoBand.txt.gz');

  it('should get chromosomes from cytoband file', function () {
    var cytoBand = new _cytoBand.CytoBandFile(remoteFile);
    var range = new _ContigInterval["default"]('chr20', 63799, 69094);

    return cytoBand.getFeaturesInRange(range).then(function (chr) {
      (0, _chai.expect)(chr.name).to.equal('chr20');
      (0, _chai.expect)(chr.position.start()).to.equal(0);
      (0, _chai.expect)(chr.position.stop()).to.equal(63025520);
      (0, _chai.expect)(chr.bands).to.have.length(20);
      (0, _chai.expect)(chr.bands[0].name).to.equal('p13');
      (0, _chai.expect)(chr.bands[0].value).to.equal('gneg');
    });
  });
});