
'use strict';

var _chai = require("chai");

var _ContigInterval = _interopRequireDefault(require("../../main/ContigInterval"));
var _GA4GHAlignmentJson = _interopRequireDefault(require("../../main/json/GA4GHAlignmentJson"));
var _RemoteFile = _interopRequireDefault(require("../../main/RemoteFile"));function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}

describe('GA4GHAlignmentJson', function () {
  var json;

  before(function () {
    return new _RemoteFile["default"]('/test-data/alignments.ga4gh.chr17.1-250.json').getAllString().then(function (data) {
      json = data;
    });
  });

  it('should filter alignments from json', function (done) {

    var source = _GA4GHAlignmentJson["default"].create(json);

    var requestInterval = new _ContigInterval["default"]('chr17', 10, 20);

    var reads = source.getFeaturesInRange(requestInterval);
    (0, _chai.expect)(reads).to.have.length(2);
    done();

  });

  it('should not fail on empty json string', function (done) {

    var source = _GA4GHAlignmentJson["default"].create("{}");

    var requestInterval = new _ContigInterval["default"]('chr17', 10, 20);

    var reads = source.getFeaturesInRange(requestInterval);
    (0, _chai.expect)(reads).to.have.length(0);
    done();

  });
});