
'use strict';

var _chai = require("chai");

var _ContigInterval = _interopRequireDefault(require("../../main/ContigInterval"));
var _GA4GHFeatureJson = _interopRequireDefault(require("../../main/json/GA4GHFeatureJson"));
var _RemoteFile = _interopRequireDefault(require("../../main/RemoteFile"));function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}

describe('GA4GHFeatureJson', function () {
  var json;

  before(function () {
    return new _RemoteFile["default"]('/test-data/features.ga4gh.chr1.120000-125000.chr17.7500000-7515100.json').getAllString().then(function (data) {
      json = data;
    });
  });

  it('should filter features from json', function (done) {

    var source = _GA4GHFeatureJson["default"].create(json);

    var requestInterval = new _ContigInterval["default"]('chr1', 130000, 135000);

    var features = source.getFeaturesInRange(requestInterval);
    (0, _chai.expect)(features).to.have.length(2);
    done();

  });

  it('should not fail on empty json string', function (done) {

    var source = _GA4GHFeatureJson["default"].create("{}");

    var requestInterval = new _ContigInterval["default"]('chr17', 10, 20);

    var reads = source.getFeaturesInRange(requestInterval);
    (0, _chai.expect)(reads).to.have.length(0);
    done();

  });

});