
'use strict';

var _chai = require("chai");

var _ContigInterval = _interopRequireDefault(require("../../main/ContigInterval"));
var _IdiogramJson = _interopRequireDefault(require("../../main/json/IdiogramJson"));
var _RemoteFile = _interopRequireDefault(require("../../main/RemoteFile"));function _interopRequireDefault(obj) {return obj && obj.__esModule ? obj : { "default": obj };}

describe('IdiogramJson', function () {
  var json;

  before(function () {
    return new _RemoteFile["default"]('/test-data/gstained_chromosomes_data.json').getAllString().then(function (data) {
      json = data;
    });
  });

  it('should filter features from json', function (done) {

    var source = _IdiogramJson["default"].create(json);

    var requestInterval = new _ContigInterval["default"]('chr1', 130000, 135000);

    var features = source.getFeaturesInRange(requestInterval)[0];
    (0, _chai.expect)(features.bands).to.have.length(63);
    done();

  });

  it('should not fail on empty json string', function (done) {

    var source = _IdiogramJson["default"].create("{}");

    var requestInterval = new _ContigInterval["default"]('chr17', 10, 20);

    var chromosomes = source.getFeaturesInRange(requestInterval);
    (0, _chai.expect)(chromosomes).to.have.length(0);
    done();

  });
});